// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'angular-md5','ngCordova','ionicLazyLoad'])
.config(function($ionicConfigProvider) {
        $ionicConfigProvider.views.swipeBackEnabled(false);
        $ionicConfigProvider.scrolling.jsScrolling(false);
        })
.run(function ($ionicPlatform, $location,$ionicLoading,$ionicHistory, $ionicPopup,  $cordovaAppVersion, $state, $timeout,$rootScope, $window,  $http, share) {
     $ionicPlatform.ready(function() {
                          if (window.cordova && window.cordova.plugins.Keyboard) {
                          
                          // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                          // for form inputs)
                          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                          
                          // Don't remove this line unless you know what you are doing. It stops the viewport
                          // from snapping when text inputs are focused. Ionic handles this internally for
                          // a much nicer keyboard experience.
                          cordova.plugins.Keyboard.disableScroll(true);
                          }
                          if (window.StatusBar) {
                          StatusBar.styleDefault();
                          }
                          
                          //极光推送初始化
                          localStorage.notifyNum = 0;
                          try {
                              window.plugins.jPushPlugin.init();
                              //getRegistrationID();
                              window.plugins.jPushPlugin.getRegistrationID(onGetRegistrationID);
                          
                          if (device.platform != "Android") {
                          // window.plugins.jPushPlugin.setDebugModeFromIos();
                          window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
                          } else {
                          window.plugins.jPushPlugin.setDebugMode(false);
                          window.plugins.jPushPlugin.setStatisticsOpen(true);
                          }
                          } catch (exception) {
                          console.log(exception);
                          }
                          
                          var getRegistrationID = function() {
                          window.plugins.jPushPlugin.getRegistrationID(onGetRegistrationID);
                          };
                          
                          var onGetRegistrationID = function(data) {
                          try {
                          console.log("JPushPlugin:registrationID is " + data);
                          
                          if (data.length == 0) {
                          var t1 = window.setTimeout(getRegistrationID, 1000);
                          }
                          // $("#registrationId").html(data);
                          } catch (exception) {
                          console.log(exception);
                          }
                          };
                          
                          var onOpenNotification = function(event) {
                              console.log('onOpenNotification')
                              try {
                              if (device.platform == "Android") {
                              var notes = window.plugins.jPushPlugin.receiveNotification;
                              gotostate(notes.extras.xhpage,notes.extras.xhid,notes.extras.xhid.commentid);
                              } else {
                              //{alert: "测试活动22，123", badge: 1, sound: "default"}
                              gotostate(event.xhpage,event.xhid,event.commentid);
                              
                              }
                              localStorage.notifyNum += 1;
                              } catch (exception) {
                              console.log("JPushPlugin:onOpenNotification" + exception);
                              }
                          };
                          
                          var showMessagePopup = function(content,page,id,commentid){
                          
                          if ($location.path() != '/login') {
                          var popup = $ionicPopup.show({
                                                       title: '小花消息',
                                                       template: content,
                                                       buttons: [{
                                                                 text: '关闭',
                                                                 onTap: function(e) {
                                                                 popup.close();
                                                                 }
                                                                 },{
                                                                 text: '去看看',
                                                                 onTap: function(e) {
                                                                 gotostate(page,id,commentid);
                                                                 }
                                                                 }]
                                                       });
                          }
                          }
                          
                          var gotostate = function(page,id,cid){
                          window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
                          if(localStorage.authTocken){
                             $timeout(function(){
                                   switch(page){
                                   case 'column':
                                   $state.go('content.column', {
                                             columnId: id,
                                             commentId:cid
                                             });
                                   if(cid){
                                   $http.get('http://missxiaohua.com/rest/mc/markRead' ,{
                                             params: {
                                             reqStr: {
                                             commentId:cid,
                                             columnId:id,
                                             doctorId:null
                                             }
                                             }
                                             }).then(function(){
                                                     localStorage.messagNum -= 1
                                                     })
                                   }
                                   break;
                                   case 'project':
                                   $state.go('content.projectDetail', {
                                             projectId: id
                                             });
                                   break;
                                   case 'doctor':
                                   $state.go('content.doctorDetail', {
                                             doctorId: id,
                                             commentId:cid
                                             });
                                   if(cid){
                                   $http.get('http://missxiaohua.com/rest/mc/markRead' ,{
                                             params: {
                                             reqStr: {
                                             commentId:cid,
                                             columnId:null,
                                             doctorId:id
                                             }
                                             }
                                             }).then(function(){
                                                     localStorage.messagNum -= 1
                                             })
                                   }
                                   break;
                                   case 'consult':
                                   $state.go('content.consult');
                                   break;
                                   default:
                                   $state.go('content.home');
                                   break;
                                   }
                                   },300);
                          }else{
                               $timeout(function(){
                                   $state.go('login',{page:page,id:id});
                                   },10);
                          //localStorage.pushtostate = {page:page,id:id};
                          }
                          }
                          
                          var onReceiveNotification = function(event) {
                              console.log('receiveNotification')
                              try {
                              if (device.platform == "Android") {
                              var notes = window.plugins.jPushPlugin.receiveNotification;
                              showMessagePopup(notes.alert,notes.extras.xhpage,notes.extras.xhid,notes.extras.commentid);
                              
                              } else {
                              //{alert: "测试活动22，123", badge: 1, sound: "default"}
                              showMessagePopup(event.aps.alert,event.xhpage,event.xhid,event.commentid);
                              
                              }
                              localStorage.notifyNum += 1;
                              } catch (exception) {
                              console.log(exception)
                              }
                          };
                          
                          var onReceiveMessage = function(event) {
                              try {
                              var message;
                              if (device.platform == "Android") {
                              message = window.plugins.jPushPlugin.receiveMessage.message;
                              } else {
                              message = event.content;
                              }
                              // showMessagePopup(message,event.xhpage,event.xhid);
                              } catch (exception) {
                                  console.log("JPushPlugin:onReceiveMessage-->" + exception);
                              }
                          };
                          
                          var onTagsWithAlias = function(event){
                                  window.plugins.jPushPlugin.getRegistrationID(function(id){
                                      //将获取到的id存入服务端
                                      //alert(id);这里就可以获取到注册的ID了
                                      
                               });
                              try {
                                  var result = "result code:" + event.resultCode + " ";
                                  result += "tags:" + event.tags + " ";
                                  result += "alias:" + event.alias + " ";
                                  } catch(exception) {
                                  console.log(exception);
                              }
                          
                          }
                          document.addEventListener("jpush.setTagsWithAlias", onTagsWithAlias, false);
                          document.addEventListener("jpush.openNotification", onOpenNotification, false);
                          document.addEventListener("jpush.receiveNotification", onReceiveNotification, false);
                          document.addEventListener("jpush.receiveMessage", onReceiveMessage, false);
                          
                          //初始化友盟统计
                          window.plugins.umengAnalyticsPlugin.init();
                          
                          
                          //重写window.open实现inapp浏览外部页面
                          window.open = window.cordova.InAppBrowser.open;
                          
                          //检查更新
                          //从服务端获取最新版本
                          $timeout(function() {
                                   $http.get('http://missxiaohua.com/rest/hello/version').then(function (response) {
                                                                                               var serverAppVersion = response.data.obj.apkVersion;
                                                                                               var serverAppUrl = response.data.obj.apkUrl;
                                                                                               if(device.platform != "Android"){
                                                                                               serverAppUrl='https://appsto.re/cn/RXvtbb.i';
                                                                                               serverAppVersion=response.data.obj.iosVersion;
                                                                                               }else{
                                                                                               serverAppUrl='http://a.app.qq.com/o/simple.jsp?pkgname=com.missxiaohua.app';
                                                                                               serverAppVersion=response.data.obj.androidVersion;
                                                                                               }
                                                                                               //获取本地版本
                                                                                               $cordovaAppVersion.getVersionNumber().then(function (version) {
                                                                                                                                          //如果本地于服务端的APP版本不符合
                                                                                                                                          if ('v'+version != serverAppVersion) {
                                                                                                                                          var confirmPopup = $ionicPopup.confirm({
                                                                                                                                                                                 title: '版本升级',
                                                                                                                                                                                 template: '“小花”发现新版本，建议您更新', //从服务端获取更新的内容
                                                                                                                                                                                 cancelText: '放弃',
                                                                                                                                                                                 okText: '去升级'
                                                                                                                                                                                 }).then(function(res) {
                                                                                                                                                                                         if(res) {
                                                                                                                                                                                         var _w = window.open(serverAppUrl,'_blank');
                                                                                                                                                                                         $timeout(function() { _w.close() }, 1000);
                                                                                                                                                                                         } else {
                                                                                                                                                                                         
                                                                                                                                                                                         }
                                                                                                                                                                                         });
                                                                                                                                          }
                                                                                                                                          });
                                                                                               })
                                   
                                   
                                   },1000);
                          
                          
                          });
     
     
     //物理返回按钮控制&双击退出应用
     $rootScope.backButtonPressedOnceToExit = false;
     $ionicPlatform.registerBackButtonAction(function (e) {
                                             //判断处于哪个页面时双击退出
                                             if ($location.path() == '/content/home'|| $location.path() == '/login') {
                                             if ($rootScope.backButtonPressedOnceToExit) {
                                             ionic.Platform.exitApp();
                                             } else {
                                             $rootScope.backButtonPressedOnceToExit = true;
                                             //  $ionicLoading.show({template:'再按一次离开小花'});
                                             $timeout(function() {  $rootScope.backButtonPressedOnceToExit = false; }, 2000);
                                             }
                                             }else if ($ionicHistory.backView()) {
                                             if (cordova.plugins.Keyboard.isVisible) {
                                             cordova.plugins.Keyboard.close();
                                             } else {
                                             $ionicHistory.goBack();
                                             }
                                             
                                             }else {
                                             $rootScope.backButtonPressedOnceToExit = true;
                                             $ionicLoading.show({template:'再按一次离开小花'});
                                             $timeout(function() {  $rootScope.backButtonPressedOnceToExit = false; }, 2000);
                                             }
                                             e.preventDefault();
                                             return false;
                                             }, 101);
     
     
     //全局控制导航上回退按钮
     $rootScope.customGoBack=function(){
         if ($ionicHistory.backView().stateName == 'login') {
         $state.go('content.home');
         } else {
         $ionicHistory.goBack();
         }
     }
     //全局控制分享
     $rootScope.doSharing = function(){
         share.popup(document.title,$location.path().split('/content/')[1],$location.url());
     }
    
     $rootScope.setPushAlias = function(alias){
        $timeout(function(){window.plugins.jPushPlugin.setAlias(''+alias);},3000);
     }

     //全局控制美恰客服IM
     $rootScope.$on('$stateChangeStart',function(event, toState, toStateParams, fromState, fromStateParams){
                    if(toState.name.indexOf('projectDetail')!=-1){
                    $timeout(function(){
                             $('#MEIQIA-BTN-HOLDER').show();
                             },500);
                    }else{
                    $('#MEIQIA-BTN-HOLDER').hide();
                    }

                  if(localStorage.authTocken&&toState.name.indexOf('login')!=-1){
                    $state.go("content.home");
                    event.preventDefault();
                }
                    })
     })
.constant("$ionicLoadingConfig",{
          noBackdrop: true,
          hideOnStateChange: true,
          duration:1500
          })
.factory('authInterceptor', function($rootScope){
         return {
             request: function(config){
                  config.headers = config.headers || {};
                  if(localStorage.authTocken){
                    // config.headers.Authorization =  localStorage.authTocken;
                    config.headers['Cookie'] = 'JSESSIONID='+localStorage.authTocken;
                 }
                 return config;
             },
             responseError: function(response){
                /* if (response.code === 453 ) {
                     // 用户无权限时跳转到登录页
                     $rootScope.go('/login');
                 }
                 return $q.reject(response);
               */
              }
         };
         })
.config(function($httpProvider){
        $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
      //  $httpProvider.defaults.headers.post['Accept'] = 'http://missxiaohua.com/';
       // $httpProvider.defaults.withCredentials = true;
        //  $httpProvider.defaults.headers.post['X-CSRFToken'] ＝ localStorage.authTocken;
        
        var param = function(obj) {
        var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
        
        for(name in obj) {
        value = obj[name];
        
        if(value instanceof Array) {
        for(i=0; i<value.length; ++i) {
        subValue = value[i];
        fullSubName = name + '[' + i + ']';
        innerObj = {};
        innerObj[fullSubName] = subValue;
        query += param(innerObj) + '&';
        }
        }
        else if(value instanceof Object) {
        for(subName in value) {
        subValue = value[subName];
        fullSubName = name + '[' + subName + ']';
        innerObj = {};
        innerObj[fullSubName] = subValue;
        query += param(innerObj) + '&';
        }
        }
        else if(value !== undefined && value !== null)
        query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
        }
        
        return query.length ? query.substr(0, query.length - 1) : query;
        };
        
        // Override $http service's default transformRequest
        $httpProvider.defaults.transformRequest = [function(data) {
                                                   return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
                                                   }];
        $httpProvider.interceptors.push('authInterceptor');
        })
/*.config(function($httpProvider) {
 $httpProvider.interceptors.push(function($rootScope) {
 return {
 request: function(config) {
 $rootScope.$broadcast('loading:show')
 return config
 },
 response: function(response) {
 $rootScope.$broadcast('loading:hide')
 return response
 }
 }
 })
 })
 
 $scope.$on('$viewContentLoading',
 function(event, viewConfig){
 // 获取任何视图设置的参数，以及一个特殊的属性：viewConfig.targetView
 });
 
 .run(function($rootScope, $ionicLoading) {
 $rootScope.$on('loading:show', function() {
 $ionicLoading.show({template: '<img src="img/loading.gif"/>',noBackdrop: false})
 })
 
 $rootScope.$on('loading:hide', function() {
 $ionicLoading.hide()
 })
 })*/

