angular.module('starter')
.filter('trustHtml', function ($sce) {
        return function (text) {
        return $sce.trustAsHtml(text);
        }
        });
angular.module('starter')
.factory('CityList', function () {
         var where = new Array(34);
         function comefrom(province, city) {
         this.province = province;
         this.city = city;
         }
         where[0] = new comefrom("北京", "北京市");
         where[1] = new comefrom("上海", "上海市");
         where[2] = new comefrom("天津", "天津市");
         where[3] = new comefrom("重庆", "重庆市");
         where[4] = new comefrom(
                                 "四川",
                                 "成都市|自贡市|攀枝花市|泸州市|德阳市|绵阳市|广元市|遂宁市|内江市|乐山市|南充市|眉山市|宜宾市|广安市|达州市|雅安市|巴中市|资阳市|阿坝藏族羌族自治州|甘孜藏族自治州|凉山彝族自治州");
         where[5] = new comefrom("贵州",
                                 "贵阳市|六盘水市|遵义市|安顺市|铜仁地区|黔西南布依族苗族自治州|毕节地区|黔东南苗族侗族自治州|黔南布依族苗族自治州");
         where[6] = new comefrom(
                                 "云南",
                                 "昆明市|曲靖市|玉溪市|保山市|昭通市|丽江市|思茅市|临沧市|楚雄彝族自治州|红河哈尼族彝族自治州|文山壮族苗族自治州|西双版纳傣族自治州|大理白族自治州|德宏傣族景颇族自治州|怒江傈僳族自治州|迪庆藏族自治州");
         where[7] = new comefrom("西藏", "拉萨市|昌都地区|山南地区|日喀则地区|那曲地区|阿里地区|林芝地区");
         where[8] = new comefrom("河南",
                                 "郑州市|开封市|洛阳市|平顶山市|安阳市|鹤壁市|新乡市|焦作市|濮阳市|许昌市|漯河市|三门峡市|南阳市|商丘市|信阳市|周口市|驻马店市");
         where[9] = new comefrom("湖北",
                                 "武汉市|黄石市|十堰市|宜昌市|襄樊市|鄂州市|荆门市|孝感市|荆州市|黄冈市|咸宁市|随州市|恩施土家族苗族自治州");
         where[10] = new comefrom("湖南",
                                  "长沙市|株洲市|湘潭市|衡阳市|邵阳市|岳阳市|常德市|张家界市|益阳市|郴州市|永州市|怀化市|娄底市|湘西土家族苗族自治州");
         where[11] = new comefrom(
                                  "广东",
                                  "广州市|韶关市|深圳市|珠海市|汕头市|佛山市|江门市|湛江市|茂名市|肇庆市|惠州市|梅州市|汕尾市|河源市|阳江市|清远市|东莞市|中山市|潮州市|揭阳市|云浮市");
         where[12] = new comefrom("广西",
                                  "南宁市|柳州市|桂林市|梧州市|北海市|防城港市|钦州市|贵港市|玉林市|百色市|贺州市|河池市|来宾市|崇左市");
         where[13] = new comefrom("陕西", "西安市|铜川市|宝鸡市|咸阳市|渭南市|延安市|汉中市|榆林市|安康市|商洛市");
         where[14] = new comefrom("甘肃",
                                  "兰州市|嘉峪关市|金昌市|白银市|天水市|武威市|张掖市|平凉市|酒泉市|庆阳市|定西市|陇南市|临夏回族自治州|甘南藏族自治州");
         where[15] = new comefrom("青海",
                                  "西宁市|海东地区|海北藏族自治州|黄南藏族自治州|海南藏族自治州|果洛藏族自治州|玉树藏族自治州|海西蒙古族藏族自治州");
         where[16] = new comefrom("宁夏", "银川市|石嘴山市|吴忠市|固原市|中卫市");
         where[17] = new comefrom(
                                  "新疆",
                                  "乌鲁木齐市|克拉玛依市|吐鲁番地区|哈密地区|昌吉回族自治州|博尔塔拉蒙古自治州|巴音郭楞蒙古自治州|阿克苏地区|克孜勒苏柯尔克孜自治州|喀什地区|和田地区|伊犁哈萨克自治州|塔城地区|阿勒泰地区");
         where[18] = new comefrom("河北", "石家庄市|唐山市|秦皇岛市|邯郸市|邢台市|保定市|张家口市|承德市|沧州市|廊坊市|衡水市");
         where[19] = new comefrom("山西", "太原市|大同市|阳泉市|长治市|晋城市|朔州市|晋中市|运城市|忻州市|临汾市|吕梁市");
         where[20] = new comefrom("内蒙古",
                                  "呼和浩特市|包头市|乌海市|赤峰市|通辽市|鄂尔多斯市|呼伦贝尔市|巴彦淖尔市|乌兰察布市|兴安盟|锡林郭勒盟|阿拉善盟");
         where[21] = new comefrom("江苏",
                                  "南京市|无锡市|徐州市|常州市|苏州市|南通市|连云港市|淮安市|盐城市|扬州市|镇江市|泰州市|宿迁市");
         where[22] = new comefrom("浙江", "杭州市|宁波市|温州市|嘉兴市|湖州市|绍兴市|金华市|衢州市|舟山市|台州市|丽水市");
         where[23] = new comefrom("安徽",
                                  "合肥市|芜湖市|蚌埠市|淮南市|马鞍山市|淮北市|铜陵市|安庆市|黄山市|滁州市|阜阳市|宿州市|巢湖市|六安市|亳州市|池州市|宣城市");
         where[24] = new comefrom("福建", "福州市|厦门市|莆田市|三明市|泉州市|漳州市|南平市|龙岩市|宁德市");
         where[25] = new comefrom("江西", "南昌市|景德镇市|萍乡市|九江市|新余市|鹰潭市|赣州市|吉安市|宜春市|抚州市|上饶市");
         where[26] = new comefrom("山东",
                                  "济南市|青岛市|淄博市|枣庄市|东营市|烟台市|潍坊市|济宁市|泰安市|威海市|日照市|莱芜市|临沂市|德州市|聊城市|滨州市|荷泽市");
         where[27] = new comefrom("辽宁",
                                  "沈阳市|大连市|鞍山市|抚顺市|本溪市|丹东市|锦州市|营口市|阜新市|辽阳市|盘锦市|铁岭市|朝阳市|葫芦岛市");
         where[28] = new comefrom("吉林", "长春市|吉林市|四平市|辽源市|通化市|白山市|松原市|白城市|延边朝鲜族自治州");
         where[29] = new comefrom("黑龙江",
                                  "哈尔滨市|齐齐哈尔市|鸡西市|鹤岗市|双鸭山市|大庆市|伊春市|佳木斯市|七台河市|牡丹江市|黑河市|绥化市|大兴安岭地区");
         where[30] = new comefrom("海南", "海口市|三亚市");
         where[31] = new comefrom("台湾", "台湾");
         where[32] = new comefrom("香港", "香港");
         where[33] = new comefrom("澳门", "澳门");
         
         function select() {
         with (document.addform.province) {
         var province2 = options[selectedIndex].value;
         }
         for (var i = 0; i < where.length; i++) {
         if (where[i].province == province2) {
         citys = (where[i].city).split("|");
         for (var j = 0; j < citys.length; j++) {
         with (document.addform.city) {
         length = citys.length;
         options[j].text = citys[j];
         options[j].value = citys[j];
         }
         }
         break;
         }
         }
         }
         
         function selectUpdateFormCity() {
         with (document.updateform.province) {
         var province2 = options[selectedIndex].value;
         }
         for (var i = 0; i < where.length; i++) {
         if (where[i].province == province2) {
         citys = (where[i].city).split("|");
         for (var j = 0; j < citys.length; j++) {
         with (document.updateform.city) {
         length = citys.length;
         options[j].text = citys[j];
         options[j].value = citys[j];
         }
         }
         break;
         }
         }
         }
         
         function init() {
         if (null != document.updateform) {
         with (document.updateform.province) {
         length = where.length;
         for (var k = 0; k < where.length; k++) {
         options[k].text = where[k].province;
         options[k].value = where[k].province;
         }
         options[selectedIndex].text = where[0].province;
         options[selectedIndex].value = where[0].province;
         }
         with (document.updateform.city) {
         province3 = (where[0].city).split("|");
         length = province3.length;
         for (var l = 0; l < length; l++) {
         options[l].text = province3[l];
         options[l].value = province3[l];
         }
         options[selectedIndex].text = province3[0];
         options[selectedIndex].value = province3[0];
         }
         }
         if (null != document.addform) {
         with (document.addform.province) {
         length = where.length;
         for (var k = 0; k < where.length; k++) {
         options[k].text = where[k].province;
         options[k].value = where[k].province;
         }
         options[selectedIndex].text = where[0].province;
         options[selectedIndex].value = where[0].province;
         }
         with (document.addform.city) {
         province3 = (where[0].city).split("|");
         length = province3.length;
         for (var l = 0; l < length; l++) {
         options[l].text = province3[l];
         options[l].value = province3[l];
         }
         options[selectedIndex].text = province3[0];
         options[selectedIndex].value = province3[0];
         }
         }
         }
         var cityList = [];
         for (var i = 0; i < where.length; ++i) {
         var province = where[i].province;
         var cities = where[i].city.split("|");
         cityList.push({province: province, cities: cities});
         }
         
         return cityList;
         });

angular.module('starter')
.factory('SlideDownMenu', function() {
         var selectedValues = [];
         return {
         setValue: function(key, value) {
         if (typeof key == "string") {
         selectedValues[key] = value;
         }
         },
         getValue: function(key) {
         if (selectedValues.hasOwnProperty(key)) {
         return selectedValues[key];
         }
         
         return null;
         },
         watch: function(scope, key, fun) {
         var getValueFun = "getMenuSelectedValue" + key;
         scope[getValueFun] = function() {
         return selectedValues[key];
         };
         scope.$watch(scope[getValueFun], fun);
         }
         };
         });
angular.module('starter')
.factory('User', function () {
         var userInfo = {
         /**
          * @description 当前的登陆状态，具体包括的值有：
          *     undefined: 未设置
          *     true: 登陆成功
          *     false: 登陆失败
          *     checkFailed: 检测失败
          */
         hasLogin: undefined
         };
         
         return {
         getUserInfo: function () {
         return userInfo;
         },
         setUserInfo: function (userInfoToSet) {
         return angular.extend(userInfo, userInfoToSet);
         }
         };
         });

angular.module('starter')
.factory('Utils', function () {
         return {
         isWeixin: function () {
         if (typeof this._isWeixin === 'undefined') {
         var ua = navigator.userAgent.toLowerCase();
         if (ua.match(/MicroMessenger/i) === 'micromessenger') {
            this._isWeixin = true;
         }
         else {
            this._isWeixin = false;
         }
         }
         return this._isWeixin;
         },
         getSpecificAreas:function(specificAreas) {
             if (null == specificAreas || typeof specificAreas != "string") {
                return [];
             }
             var spliter = /,|，|;|；|、/;
             var maxSplitCount = 4;
             
             return specificAreas.split(spliter, maxSplitCount);
         },
         getActivityUrl:function(_url){
             _url = _url.replace('/weixin/html/','');
             switch(_url.split('.html')[0]){
                 case 'column':
                 _url = "content.column({columnId:"+ _url.split('columnId=')[1]+"})";
                 break;
                 case 'project_detail':
                 _url = "content.projectDetail({projectId:'"+ _url.split('projectId=')[1]+"'})";
                 break;
                 default:break
             }
             return _url;
         },
         getElementSize: function (selector) {
         var element = $(selector).eq(0);
         if (!element) {
         return {width: 0, height: 0};
         }
         return {
         width: element.width(),
         height: element.height()
         };
         },
         getStyledImageUrl: function (imgSrc, size) {
         var options = {
         image: {
         picQual: 100,
         maxWidth: 800
         }
         };
         
         if (!imgSrc || typeof imgSrc !== "string") {
         return imgSrc;
         }
         
         if (!/^.*oss.*aliyuncs\.com.*$/.test(imgSrc)) {
         return imgSrc;
         }
         
         var imgUrl = imgSrc.replace(".oss-", ".img-");
         var style = "@";
         if (size && typeof size.width === 'number') {
         style += "_" + ((size.width > options.image.maxWidth) ? options.image.maxWidth : size.width) + "w";
         }
         if (size && typeof size.height === 'number') {
         style += "_" + size.height + "h";
         }
         if (size.width && size.height) {
         style += "_2e";
         }
         style += "_" + options.image.picQual + "q";
         
         return imgUrl + style;
         },
         format2Param: function (obj) {
         if (null === obj || typeof obj !== "object") {
         return "";
         }
         
         var search = "";
         var isFirst = true;
         for (var key in obj) {
         if (!obj.hasOwnProperty(key)) {
         continue;
         }
         search += (isFirst ? "" : "&") + encodeURI(key) + "=" + encodeURI(obj[key]);
         if (isFirst) {
         isFirst = false;
         }
         }
         
         return search;
         },
         trimObject: function (obj) {
         if (null == obj || typeof obj != "object") {
         return obj;
         }
         
         for (var key in obj) {
         if (obj.hasOwnProperty(key) && null == obj[key]) {
         delete obj[key];
         }
         }
         
         return obj;
         },
         getUrlWithoutPath: function () {
         return window.location.protocol + "//" + window.location.host + ((window.location.port == "") ? "" : (":" + window.location.port));
         },
         doStatic : function (url) {
         var date = new Date();
         var n = "log__" + date.getTime();
         var c = window[n] = new Image();
         c.onload = (c.onerror = function () {
                     window[n] = null;
                     });
         c.src = 'http://missxiaohua.com/weixin/project-ui/imgs/tj.gif'+url;
         c = null;
         },
         getQueryString:function(name,url) {
         var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i');
         
         var r = (url.split('?')[1]).match(reg);
         if (r != null) {
         return unescape(r[2]);
         }
         return null;
         }
         };
         });


(function (module) {
 var share = function ($ionicLoading,$ionicActionSheet) {

 var gotoshare = function (index){
     if (!window.Wechat) return;
 
     Wechat.isInstalled(function (installed) {
      //alert("Wechat installed: " + (installed ? "Yes" : "No"));
      if(installed){
            var shareurl = "http://www.missxiaohua.com/weixin/html/";
            switch (shareinfo.path){
                case "home":
                shareinfo.url = "http://www.missxiaohua.com";
                break;
                case "doctorList":
                shareinfo.url = shareurl +"doctorList.html";
                break;
                case "consult":
                shareinfo.url = shareurl +"consult.html";
                break;
                case "findProject":
                shareinfo.url = shareurl +"find_project.html";
                break;
                case "projectList":
                shareinfo.url = shareurl + "projects_list.html?"+shareinfo.url.split('?')[1];
                break;
                case "projectDetail":
                shareinfo.url = shareurl + "project_detail.html?"+shareinfo.url.split('?')[1];
                shareinfo.title += '-'+ $('#project-name').html()
                break;
                case "doctorDetail":
                shareinfo.url = shareurl  + "doctor_detail.html?"+shareinfo.url.split('?')[1];
                shareinfo.title += '-'+ $.trim($('#doctor_name').html())
                shareinfo.desc = $.trim($('#hospital_name').html())+'-'+$.trim($('#doctor_title').html());
                shareinfo.thumb = $('.head_img').css('backgroundImage').split(')')[0].split('(')[1];
                break;
                case "hospitalDetail":
                shareinfo.url = shareurl + "hospital_detail.html?"+shareinfo.url.split('?')[1];
                shareinfo.title += '-'+ $('#hospital_name').html()
                break;
                case "column":
                shareinfo.url = shareurl + shareinfo.path+".html?"+shareinfo.url.split('?')[1];
                shareinfo.title +=  '-'+ $('#column-title>span:first').html()
                break;
                case "eventList":
                shareinfo.url = shareurl +"eventList.html?"+shareinfo.url.split('?')[1];
                break;
                default:
                //_url ="http://www.missxiaohua.com/";
                break;
            }
         Wechat.share({
              message: {
              title:shareinfo.title,
              description: shareinfo.desc,
              thumb: shareinfo.thumb,
              mediaTagName: "xiaohua-TAG-001",
              messageExt: "小花",
              media: {
                  type: Wechat.Type.LINK,
                  webpageUrl: shareinfo.url
              }
          },
          scene: index  // share to Timeline
          }, function () {
                   $ionicLoading.show({
                                      template:(index!='2'?'分享成功':'收藏成功')})
          }, function (reason) {
                   $ionicLoading.show({
                                      template:'分享失败'})
          });
          }else{
                   $ionicLoading.show({
                                           template:'您未安装微信无法分享'})
          }
          }, function (reason) {
                        $ionicLoading.show({
                                           template:'分享失败'+reason
                                           })
      });
 }
 
 var shareinfo = { }
 
 var showPopupShare = function (_title, _path, _url) {
     shareinfo ={
          title : _title,
          url: _url,
          path:_path,
          desc:'全国的好医生都在小花',
          thumb:'www/img/default_user_head.png'
     }
 
     var sheet = {};
     sheet.titleText = '分享到';
     sheet.cancelText = '取消';
     sheet.buttonClicked = gotoshare;
     sheet.cssClass = 'share-wrap';
     sheet.buttons = [{
                      text: '<img class="static" src="img/weixin-friend.png">微信好友'
                      }, {
                      text: '<img  class="static" src="img/weixin-timeline.png">朋友圈'
                      }, {
                      text: '<img  class="static" src="img/weixin-save.png">收藏'
                      }];
                     /*, {
                      text: '<img  class="static" src="img/qq-friend.png">QQ好友'
                      }, {
                      text: '<img  class="static" src="img/qzone.png">Qzone'
                      }, {
                      text: '<img  class="static" src="img/weibo.png">新浪微博'
                      }*/
     $ionicActionSheet.show(sheet);
 };
 
     return {
        popup: showPopupShare
     };
};
 
     module.factory("share",
                    ['$ionicLoading','$ionicActionSheet', share]);
 
 }(angular.module("starter")));

/**
 * Created by PAVEI on 30/09/2014.
 * Updated by Ross Martin on 12/05/2014
 * Updated by Davide Pastore on 04/14/2015
 * Updated by Michel Vidailhet on 05/12/2015
 * Updated by Rene Korss on 11/25/2015
 */

angular.module('ionicLazyLoad', []);
angular.module('ionicLazyLoad')
.directive('lazyScroll', ['$rootScope',
                          function($rootScope) {
                          return {
                          restrict: 'A',
                          link: function ($scope, $element) {
                          var origEvent = $scope.$onScroll;
                          $scope.$onScroll = function () {
                          $rootScope.$broadcast('lazyScrollEvent');
                          
                          if(typeof origEvent === 'function'){
                          origEvent();
                          }
                          };
                          }
                          };
                          }])

.directive('imageLazySrc', ['$document', '$timeout', '$ionicScrollDelegate', '$compile',
                            function ($document, $timeout, $ionicScrollDelegate, $compile) {
                            return {
                            restrict: 'A',
                            scope: {
                            lazyScrollResize: "@lazyScrollResize",
                            imageLazyBackgroundImage: "@imageLazyBackgroundImage",
                            imageLazySrc: "@"
                            },
                            link: function ($scope, $element, $attributes) {
                            if (!$attributes.imageLazyDistanceFromBottomToLoad) {
                            $attributes.imageLazyDistanceFromBottomToLoad = 0;
                            }
                            if (!$attributes.imageLazyDistanceFromRightToLoad) {
                            $attributes.imageLazyDistanceFromRightToLoad = 0;
                            }
                            
                            var loader;
                            if ($attributes.imageLazyLoader) {
                            loader = $compile('<div class="image-loader-container"><ion-spinner class="image-loader" icon="' + $attributes.imageLazyLoader + '"></ion-spinner></div>')($scope);
                            $element.after(loader);
                            }
                            
                            $scope.$watch('imageLazySrc', function (oldV, newV) {
                                          if(loader)
                                          loader.remove();
                                          if ($attributes.imageLazyLoader) {
                                          loader = $compile('<div class="image-loader-container"><ion-spinner class="image-loader" icon="' + $attributes.imageLazyLoader + '"></ion-spinner></div>')($scope);
                                          $element.after(loader);
                                          }
                                          var deregistration = $scope.$on('lazyScrollEvent', function () {
                                                                          //    console.log('scroll');
                                                                          if (isInView()) {
                                                                          loadImage();
                                                                          deregistration();
                                                                          }
                                                                          }
                                                                          );
                                          $timeout(function () {
                                                   if (isInView()) {
                                                   loadImage();
                                                   deregistration();
                                                   }
                                                   }, 500);
                                          });
                            var deregistration = $scope.$on('lazyScrollEvent', function () {
                                                            // console.log('scroll');
                                                            if (isInView()) {
                                                            loadImage();
                                                            deregistration();
                                                            }
                                                            }
                                                            );
                            
                            function loadImage() {
                            //Bind "load" event
                            $element.bind("load", function (e) {
                                          if ($attributes.imageLazyLoader) {
                                          loader.remove();
                                          }
                                          if ($scope.lazyScrollResize == "true") {
                                          //Call the resize to recalculate the size of the screen
                                          $ionicScrollDelegate.resize();
                                          }
                                          $element.unbind("load");
                                          });
                            
                            if ($scope.imageLazyBackgroundImage == "true") {
                            var bgImg = new Image();
                            bgImg.onload = function () {
                            if ($attributes.imageLazyLoader) {
                            loader.remove();
                            }
                            $element[0].style.backgroundImage = 'url(' + $attributes.imageLazySrc + ')'; // set style attribute on element (it will load image)
                            if ($scope.lazyScrollResize == "true") {
                            //Call the resize to recalculate the size of the screen
                            $ionicScrollDelegate.resize();
                            }
                            };
                            bgImg.src = $attributes.imageLazySrc;
                            } else {
                            $element[0].src = $attributes.imageLazySrc; // set src attribute on element (it will load image)
                            }
                            }
                            
                            function isInView() {
                            var clientHeight = $document[0].documentElement.clientHeight;
                            var clientWidth = $document[0].documentElement.clientWidth;
                            var imageRect = $element[0].getBoundingClientRect();
                            return (imageRect.top >= 0 && imageRect.top <= clientHeight + parseInt($attributes.imageLazyDistanceFromBottomToLoad))
                            && (imageRect.left >= 0 && imageRect.left <= clientWidth + parseInt($attributes.imageLazyDistanceFromRightToLoad));
                            }
                            
                            // bind listener
                            // listenerRemover = scrollAndResizeListener.bindListener(isInView);
                            
                            // unbind event listeners if element was destroyed
                            // it happens when you change view, etc
                            $element.on('$destroy', function () {
                                        deregistration();
                                        });
                            
                            // explicitly call scroll listener (because, some images are in viewport already and we haven't scrolled yet)
                            $timeout(function () {
                                     if (isInView()) {
                                     loadImage();
                                     deregistration();
                                     }
                                     }, 500);
                            }
                            };
                            }]);
angular.module('starter')
.directive('autoFocusWhen',['$timeout', function($timeout) {
     return {
     restrict: 'A',
     scope: {
     autoFocusWhen: '='
     },
     link: function(scope, element) {
     scope.$watch('autoFocusWhen', function(newValue) {
                  if (newValue) {
                      $timeout(function(){
                                 element[0].focus();
                               },1000)
                      }
                  });
     
     element.on('blur', function() {
                scope.$apply(function() {
                             scope.autoFocusWhen = false;
                             })
                })
     }
           }
                            }])
angular.module('starter')
.directive('selectMainCategory', function () {
           return {
           restrict: 'E',
           scope: false,
           replace: true,
           transclude: true,
           template: '<div><ion-item class="main-category-item" on-tap="addSelectStyle();onMainCategoryClick($index)" ng-transclude></ion-item><div class="main-category-item-divider"></div></div>',
           link: function (scope, iElement, iAttrs, controller) {
           // The first element selected automatically.
           angular.element('ion-item.main-category-item').eq(0).addClass("main-category-selected");
           scope.addSelectStyle = function() {
           angular.element('ion-item.main-category-item').removeClass("main-category-selected");
           iElement.children().eq(0).addClass("main-category-selected");
           };
           }
           }
           });

angular.module('starter')
.directive('xhDownMenuItemSet', function () {
           function getUniqId() {
           var date = new Date();
           var id = date.getTime();
           var random = Math.floor(Math.random() * 10000);
           id += random;
           return id;
           }
           
           return {
           restrict: 'E',
           replace: true,
           transclude: true,
           template: '<div class="xh-down-menu-item-set" ng-transclude></div>',
           link: function(scope, iElement, iAttrs, controller) {
           iElement.data("menuItemSetId", getUniqId());
           }
           }
           });

angular.module('starter')
.directive('xhDownMenuItem', function () {
           return {
           restrict: 'E',
           scope: true,
           replace: true,
           transclude: true,
           require: '^?xhDownMenu',
           template: '<div class="xh-down-menu-item" ng-click="onMenuItemClick($event)" ng-transclude></div>',
           link: function (scope, iElement, iAttrs, controller) {
           var isMenuClosed = true;
           var menuContent = iElement.children(".xh-down-menu-item-set");
           var menuInfo = getMenuInfo();
           if (1 == menuContent.length) {  // Has sub menu.
           menuContent = menuContent.eq(0);
           menuContent.addClass("menu-close");
           menuContent.css("width", getWidthPercent(menuInfo.totalLayer));
           menuContent.css("layer", menuInfo.curLayer);
           menuContent.css("left", getLeftPercent());
           buildChainRelationShip();
           }
           else {  // Has no sub menu.
           menuContent = null;
           }
           
           scope.onMenuItemClick = function($event) {
           // The leaf.
           if (null == menuContent) {
           // Here is of sense when the siblings has more layers than the current and is now spread.
           closeSiblingMenu();
           iElement[0].closeMenuUp();
           var value = iElement.children(".xh-item-name").attr("value");
           var name = iElement.children(".xh-item-name").attr("name");
           controller.setSelectedItem(name);
           controller.setSelectedValue(value);
           }
           // Not leaf and close, then close other siblings and spread the menu.
           else if(isMenuClosed) {
           // Close other siblings.
           var siblings = controller.getElementSiblings(iElement);
           for (var i = 0; i < siblings.length; ++i) {
           siblings[i].closeMenuDown();
           siblings[i].removeClass("xh-down-menu-item-stress");
           }
           menuContent.toggleClass("menu-close");
           isMenuClosed = !isMenuClosed;
           iElement.addClass("xh-down-menu-item-stress");
           var value = iElement.children(".xh-item-name").attr("value");
           controller.appendSelectedValue(value);
           
           moveToRootMenu();
           }
           // Not leaf but spread, then close the menu down.
           else {
           iElement.closeMenuDown();
           iElement.removeClass("xh-down-menu-item-stress");
           controller.removeLastValue();
           }
           
           // Do not propagate.
           $event.stopPropagation();
           };
           
           // Close menu from leaf to root recursively.
           iElement[0].closeMenuUp = function() {
           moveCurrentMenuBack();
           
           var parentItemSet = iElement.parent();
           isMenuClosed = !isMenuClosed;
           parentItemSet.toggleClass("menu-close");
           iElement.removeClass("xh-down-menu-item-stress");
           
           var parentItem = parentItemSet.parent();
           if (parentItem) {
           parentItem[0].closeMenuUp();
           }
           }
           
           // Close menu from parent to leaf.
           iElement.closeMenuDown = function() {
           if (isMenuClosed || menuContent == null) {
           return;
           }
           
           moveSubMenuBack();
           
           menuContent.toggleClass("menu-close");
           isMenuClosed = !isMenuClosed;
           iElement.removeClass("xh-down-menu-item-stress");
           
           // Here has efficient problem.
           // Needn't close all siblings for they must be closed.
           var siblings = controller.getElementSiblings(iElement);
           for (var i = 0; i < siblings.length; ++i) {
           siblings[i].closeMenuDown();
           }
           
           controller.removeLastValue();
           }
           
           // Move to the root node to display.
           // For style="-webkit-transform: translate3d(0px, 0px, 0px) scale(1);".
           // Seems so stupid, but right now have no choice.
           function moveToRootMenu() {
           if (null != menuContent) {
           menuInfo.rootElem.append(menuContent);
           }
           }
           
           // Move parent menu back when close up menu.
           function moveCurrentMenuBack() {
           var menuItemSet = controller.getMenuItemSet(iElement);
           if (null != menuItemSet) {
           menuItemSet.parentMenu.append(menuItemSet);
           }
           }
           
           // Move sub menu back when close down menu.
           function moveSubMenuBack() {
           iElement.append(menuContent);
           }
           
           function closeSiblingMenu() {
           var siblings = controller.getElementSiblings(iElement);
           for (var i = 0; i < siblings.length; ++i) {
           siblings[i].closeMenuDown();
           }
           }
           
           // Save then logical parent and child relationship.
           function buildChainRelationShip() {
           iElement.childMenu = menuContent;
           menuContent.parentMenu = iElement;
           var subItems = menuContent.children(".xh-down-menu-item");
           controller.addMenuItem(iElement);
           controller.addMenuItemSet(menuContent);
           }
           
           function getMenuInfo() {
           var curLayer = 1;
           var curElem = iElement;
           while (!curElem.hasClass("xh-down-menu")) {
           curElem = curElem.parent();
           if (curElem.hasClass("xh-down-menu-item-set")) {
           curLayer += 1;
           }
           }
           var totalLayer = Number(curElem.attr("menu-layer"));
           if (totalLayer < 1) {
           totalLayer = 1;
           }
           
           return {curLayer: curLayer, totalLayer: totalLayer, rootElem: curElem};
           }
           
           function getWidthPercent(level) {
           switch(level) {
           case 1:
           return "100%";
           break;
           case 2:
           return "50%";
           break;
           case 3:
           return "33%";
           break;
           default:
           return "100%";
           break;
           }
           }
           
           function getLeftPercent() {
           if (menuInfo.curLayer <= 1) {
           return "0%";
           }
           switch (menuInfo.totalLayer) {
           case 2:
           if (menuInfo.curLayer == 2) {
           return "50%";
           }
           else {
           return "0%";
           }
           break;
           case 3:
           if (menuInfo.curLayer == 3) {
           return "66%";
           }
           else if (menuInfo.curLayer == 2) {
           return "33%";
           }
           else {
           return "0%";
           }
           break;
           default :
           return "0%";
           break;
           }
           }
           }
           };
           });
angular.module('starter')
.directive('xhDownMenuSet', function() {
           var lightBox = null;
           return {
           restrict: 'E',
           replace: true,
           transclude: true,
           template: '<div class="xh-down-menu-set" ng-transclude></div>',
           controller: ['$scope', '$element', '$attrs', function ($scope, $element, $attrs) {
                        var listMenus = [];
                        
                        this.addMenu = function(menu) {
                        listMenus.push(menu);
                        };
                        
                        this.closeOtherMenus = function(menu) {
                        for (var i = 0; i < listMenus.length; ++i) {
                        if (menu === listMenus[i]) {
                        continue;
                        }
                        listMenus[i].closeMenu();
                        }
                        };
                        
                        this.showLightBox = function() {
                        // lightBox.css("display", "block");
                        };
                        
                        this.hideLightBox = function() {
                        // lightBox.css("display", "none");
                        };
                        }]
           }
           });

angular.module('starter')
.directive('xhDownMenu', function (SlideDownMenu) {
           // Save the selected results splitting by ':'.
           var selectedValue = "";
           
           return {
           restrict: 'E',
           scope: true,
           replace: true,
           transclude: true,
           require: '^?xhDownMenuSet',
           template: '<div class="xh-down-menu" ng-click="onMenuClick()" ng-transclude></div>',
           controller: ['$scope', '$element', '$attrs', '$transclude', function($scope, $element, $attrs, $transclude) {
                        $scope.$watch("$viewContentLoaded", function() {
                                      $scope.selectedItemValue = $attrs["defaultValue"];
                                      });
                        var menuName = $attrs["menuName"];
                        var listItems = [];
                        var listMenuItemSets = [];
                        
                        this.setSelectedValue = function(value) {
                        this.appendSelectedValue(value);
                        SlideDownMenu.setValue(menuName, selectedValue);
                        }
                        this.appendSelectedValue = function(value) {
                        if (typeof value != "string") {
                        return;
                        }
                        
                        if (selectedValue == "") {
                        selectedValue = value;
                        }
                        else {
                        selectedValue = selectedValue + ":" + value;
                        }
                        }
                        this.removeLastValue = function() {
                        var idxColon = selectedValue.lastIndexOf(":");
                        if (-1 != idxColon) {
                        selectedValue = "";
                        }
                        else {
                        selectedValue = selectedValue.substring(0, idxColon);
                        }
                        }
                        
                        this.addMenuItem = function(item) {
                        listItems.push(item);
                        }
                        this.setSelectedItem = function(val) {
                        $scope.selectedItemValue = val;
                        }
                        this.getElementSiblings = function(element) {
                        var siblings = [];
                        for (var i = 0; i < listItems.length; ++i) {
                        var itemIParent = listItems[i].parent();
                        var elemParent = element.parent();
                        if (itemIParent.data("menuItemSetId") == elemParent.data("menuItemSetId") && !(listItems[i] === element)) {
                        siblings.push(listItems[i]);
                        }
                        }
                        
                        return siblings;
                        };
                        $element.getSubMenuItems = function() {
                        var subMenuItems = [];
                        for (var i = 0; i < listItems.length; ++i) {
                        if (listItems[i].parentElement === $element) {
                        continue;
                        }
                        subMenuItems.push(listItems[i]);
                        }
                        
                        return subMenuItems;
                        };
                        
                        this.addMenuItemSet = function(menuItemSet) {
                        listMenuItemSets.push(menuItemSet);
                        };
                        this.getMenuItemSet = function(elem) {
                        for (i = 0; i < listMenuItemSets.length; ++i) {
                        if (listMenuItemSets[i].data("menuItemSetId") == elem.parent().data("menuItemSetId")) {
                        return listMenuItemSets[i];
                        }
                        }
                        
                        return null;
                        };
                        }],
           link: function (scope, iElement, iAttrs, controller) {
           var statusIcon = iElement.children().eq(0);
           var selectedItem = iElement.children().eq(1);
           var spreadIcon = statusIcon.attr("spread-icon");
           var closeIcon = statusIcon.attr("close-icon");
           var menuLayer = Number(iElement.attr("menu-layer"));
           if (menuLayer < 1) {
           menuLayer = 1;
           }
           var isMenuClosed = true;
           
           var menuContent = iElement.children(".xh-down-menu-item-set");
           menuContent.addClass("menu-close");
           menuContent.css("width", getWidthPercent(menuLayer));
           menuContent.attr("layer", 1);
           scope.iconImage = closeIcon;
           buildChainRelationShip();
           
           controller.addMenu(iElement);
           
           scope.onMenuClick = function() {
               menuContent.toggleClass("menu-close");
               selectedItem.toggleClass("xh-selected-item-spreaded");
               isMenuClosed = !isMenuClosed;
               scope.iconImage = isMenuClosed ? closeIcon : spreadIcon;
               
               if (isMenuClosed) {
               var subMenuItems = iElement.getSubMenuItems();
               for (var i = 0; i < subMenuItems.length; ++i) {
               subMenuItems[i].closeMenuDown();
               }
               controller.hideLightBox();
               }
               else {
               // Close other siblings.
               controller.closeOtherMenus(iElement);
               // Initialize the selected value as empty.
               selectedValue = "";
               controller.showLightBox();
               }
           };
           
           iElement.closeMenu = function() {
           if (!isMenuClosed) {
           scope.onMenuClick();
           }
           };
           
           // Close menu from leaf to root recursively.
           iElement[0].closeMenuUp = function() {
           selectedItem.toggleClass("xh-selected-item-spreaded");
           isMenuClosed = !isMenuClosed;
           scope.iconImage = isMenuClosed ? closeIcon : spreadIcon;
           };
           
           function buildChainRelationShip() {
           iElement.childMenu = menuContent;
           menuContent.parentMenu = iElement;
           var children = menuContent.children(".xh-down-menu-item");
           };
           
           function getWidthPercent(level) {
           switch(level) {
           case 1:
           return "100%";
           break;
           case 2:
           return "50%";
           break;
           case 3:
           return "33.33%";
           break;
           default:
           return "100%";
           break;
           }
           }
           }
           };
           });

angular.module('starter')
.directive('xhIndicateIcon', function () {
           return {
           restrict: 'E',
           scope: false,
           replace: true,
           transclude: false
           }
           });

angular.module('starter')
.directive('xhItemName', function () {
           return {
           restrict: 'E',
           scope: false,
           replace: true,
           transclude: true,
           template: '<p class="xh-item-name" ng-transclude></p>'
           }
           });

angular.module('starter')
.directive('xhSelectedItem', function () {
           return {
           restrict: 'AE',
           scope: {
           selectedItemValue: "@"
           },
           replace: true,
           transclude: false,
           template: '<p class="xh-selected-item">{{selectedItemValue}}</p>'
           }
           });

angular.module('starter')
.directive('xhTuneBadgePosition', function ($window, $timeout) {
           return {
           restrict: 'A',
           scope: false,
           replace: false,
           transclude: false,
           link: function (scope, iElement, iAttrs, controller) {
           function getBadgePos(relativeElem, offset) {
           var pos = {top:0, left:0};
           
           if (null == relativeElem || typeof offset !== "number") {
           return pos;
           }
           var left = relativeElem.position().left;
           var width = relativeElem.width();
           var top = relativeElem.position().top;
           pos.left = left + width + offset;
           pos.top = top;
           
           return pos;
           };
           
           function tuneBadgePosition() {
           var nameElem = iElement.children(".name").eq(0);
           var position = getBadgePos(nameElem, 6);
           var badgeElem = iElement.children(".badge").eq(0);
           badgeElem.css("left", position.left);
           /*
            var doctorTitleElem = iElement.children(".doctor-title");
            if (0 != doctorTitleElem.length) {
            doctorTitleElem = doctorTitleElem.eq(0);
            var left = position.left + badgeElem.width() + 4;
            doctorTitleElem.css("left", left);
            }
            */
           };
           
           scope.$watch("$viewContentLoaded", function() {
                        var nameElem = iElement.children(".name").eq(0);
                        scope.nameInnerHtml = function() {
                        return nameElem.html();
                        }
                        scope.$watch(scope.nameInnerHtml, tuneBadgePosition);
                        /*
                         scope.namePosition = function() {
                         var posLeft = nameElem.position().left;
                         return posLeft
                         }
                         scope.$watch(scope.namePosition, tuneBadgePosition);
                         */
                        
                        angular.element($window).bind('resize', function() {
                                                      tuneBadgePosition();
                                                      });
                        tuneBadgePosition();
                        });
           }
           }
           });
angular.module('starter')
.directive('xhTuneHeight', function($window, $timeout) {
           return {
           restrict: 'A',
           link: function (scope, iElement, iAttrs, controller) {
           var ratio = parseFloat(iAttrs["xhTuneHeight"]);
           var getHeight = function() {
           var width = iElement.width();
           return width * ratio + "px";
           }
           
           var tuneHeight = function() {
           iElement.css({height: getHeight()});
           };
           
           /**
            * Get the orientation of mobile phone.
            * @returns {number} 0:vertical 1:horizontal.
            */
           scope.getOrientation = function() {
           if(window.orientation==180||window.orientation==0){
           return 0;
           }
           if(window.orientation==90||window.orientation==-90){
           return 1;
           }
           };
           
           // Resize when window orientation changes.
          // scope.$watch(scope.getOrientation, tuneHeight);
           
           // Resize when window size changes.
           angular.element($window).bind('resize', function() {
                                 //        iElement.css({height: getHeight()});
                                         });
           
           tuneHeight();
           }
           }
           });
angular.module('starter')
.controller('ChangePasswordCtrl', function ($scope, $http,$stateParams,md5, $ionicHistory) {
            $scope.userInfo = {
            oldPassword: '',
            newPassword: '',
            newPasswordConfirm: ''
            };
            
            $scope.changePasswordStatus = '';
            $scope.errorMessage = '';
            
            $scope.changeSubmit = function () {
                if ($scope.changePasswordStatus === 'loading') {
                return;
                }
                
                $scope.changePasswordStatus = '';
                $scope.errorMessage = '';
                var oldPassword = $scope.userInfo.oldPassword;
                var newPassword = $scope.userInfo.newPassword;
                var newPasswordConfirm = $scope.userInfo.newPasswordConfirm;
                
                if (oldPassword.length === 0) {
                showErrorMessage('原始密码不能为空');
                return;
                }
                
                if (newPassword.length < 6 || newPassword.length > 8) {
                showErrorMessage('密码应为6-8位数字、字母或符号');
                return;
                }
                
                if (newPassword !== newPasswordConfirm) {
                showErrorMessage('两次密码输入不一致');
                return;
                }
                
                $scope.changePasswordStatus = 'loading';
                var oldPwdMd5 =  md5.createHash(oldPassword);
                oldPwdMd5 =  md5.createHash(oldPwdMd5);
                var newPwdMd5 =  md5.createHash(newPassword);
                newPwdMd5 =  md5.createHash(newPwdMd5);
            
               $http.post('http://missxiaohua.com/rest/user/update_password',  {
                       reqStr: JSON.stringify({ userId: localStorage.userId,
                                              password: oldPwdMd5,
                                              newPassword: newPwdMd5})
                          })
                .then(function (response) {
                                         $scope.$apply(function () {
                                                       if (response.code === '200') {
                                                       $scope.changePasswordStatus = 'success';
                                                       $ionicHistory.goBack();
                                                       localStorage.password = newPwdMd5;
                                                       }
                                                       else if (response.code === '483') {
                                                       showErrorMessage('*密码错误，忘记密码请拨打010-57594368');
                                                       }
                                                       else {
                                                       showErrorMessage('修改密码失败：' + response.msg);
                                                       }
                                                       });
                                         }, function () {
                                         $scope.$apply(function () {
                                                       showErrorMessage('修改密码失败');
                                                       });
                                         });
            }
            
            function showErrorMessage(errorMessage) {
               $scope.changePasswordStatus = 'error';
               $scope.errorMessage = errorMessage;
            }
    });

angular.module('starter')
.controller('ColumnCtrl', function ($scope, $http, $stateParams,$ionicLoading,$ionicSlideBoxDelegate,Utils,$state, $timeout,$ionicScrollDelegate,$cordovaFileTransfer,$q,$ionicPopup) {
            
            var columnId = $stateParams.columnId;
            $scope.isBigShown = false;
            var stateCid = $stateParams.commentId;
            //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
           
            //上传评论图片
            $scope.picUrls = [];
            
            $scope.uploadPic = function () {
                var options = {
                 destinationType: Camera.DestinationType.FILE_URI,
                 sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                 saveToPhotoAlbum: true,
                 targetWidth: 800,
                 targetHeight: 800
                 };
                 
                 //Camera.getPicture(type)->根据选择的“选取图片”的方式进行选取
                 if($scope.picUrls.length<3){
                 navigator.camera.getPicture(function (imageURI) {
                 // $scope.me.image = imageURI;
                 //更新页面上的照片
                 $scope.picUrls.push(imageURI);
                 $scope.$apply();
                 }, function (error) {
                 //error handle
                 console.log("Error: " + error);
                 }, options);
                 }else{
                 $ionicLoading.show({
                 template: "最多支持上传三张"
                 });
                 }
            }
            
            
            $scope.removePic = function (key) {
               $scope.picUrls.splice(key, 1);
            }
            
            // console.log(document.body.scrollTop+'  '+ document.documentElement.scrollTop+'  '+ window.pageYOffset )
            //获取专栏内容
            $http.get('http://missxiaohua.com/rest/special_column/one', {
                      params: {
                            reqStr: JSON.stringify({
                                             columnId: columnId
                                             })
                      }
                      }).then(function (result) {
                              result = result.data;
                              if(200 == result.code){
                              var content = result.obj ? result.obj.content : null;
                              if (typeof content === "string") {
                                  content = content.replace(/\n|\r\n/g, "<br />");
                              }else {
                                 content = "";
                              }
                              var columnStr = '<dl>\
                              <dt></dt>\
                              <dd>\
                              <div id="column-title"><span>'+result.obj.name+'</span><br/><span>'+result.obj.createTime+'</span\></div>\
                              <p>'+content+'</p>\
                              </dd>\
                              </dl>';
                              $(".columnWrap").html(columnStr);
                              if($('.columnWrap .edui-upload-video').length!=0){
                                 $('.edui-upload-video').each(function(){
                                            $(this).attr('src','http://missxiaohua.com'+$(this).attr('src'));
                                                           })
                              }
                              $(".columnWrap p a").on('click',function(e){
                                      e.preventDefault();
                                      var href = $(this).attr('href');
                                      if(href.indexOf('credit')!=-1)
                                         $state.go('content.userCenter.credits')
                                      else
                                         window.open(href, '_blank');
                                      })
                              }else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            
            //评论点赞
            $scope.praiseComment = function(flag,commentId,idx) {
  
                if (flag != null) {
                   return;
                }
            
                $http.get('http://missxiaohua.com/rest/column_comment/praise', {
                          params: {
                             reqStr: JSON.stringify({commentId: commentId})
                          }
                          }).then(function(result){
                                    result = result.data;
                                    if (200 != result.code) {
                                       $ionicLoading.show({
                                              template: '服务器错误,'+result.msg
                                              });
                                       }
                                       $scope.reviewInfo.reviewList[idx].isUserPraised = true;
                                       $scope.reviewInfo.reviewList[idx].praiseCount+= 1;
                                
                                   })
            }
            
            //举报
             $scope.reportComment=function(flag, commentId, idx) {
                if (flag) {
                    return;
                 }
            
                  var popup = $ionicPopup.show({
                                         title: '评论举报',
                                         template: '<p style="font-size:14px;">确定要举报此内容</p>',
                                         scope: $scope,
                                         buttons: [{
                                                   text: '取消',
                                                      onTap: function(e) {
                                                         popup.close();
                                                   }
                                                   },{
                                                   text: '确认',
                                                   onTap: function(e) {
                                                       $http.get('http://missxiaohua.com/rest/column_comment/report', {
                                                             params: {
                                                                reqStr: JSON.stringify({commentId: commentId})
                                                             }
                                                             }).then(function (response) {
                                                                if (response.data.code === '200') {
                                                                     var resultPopup = $ionicPopup.alert({
                                                                         title: '举报成功',
                                                                         cssClass:'no-btns',
                                                                         template: '<p style="font-size:12px;padding-bottom:12px;">感谢您加入我们来共同维护平台环境，我们会马上对此评论进行严格审核</p>'
                                                                                        });
                                                                     $scope.reviewInfo.reviewList[idx].isUserReported = true;
                            
                                                                     }
                                                                      $timeout(function(){resultPopup.close();},2000);
                                                                     })
                                                   }
                                                   }]
                                         });

            
            }
            $scope.reviewInfo = {
                reviewList: [],
                showAllReview: '',
                reviewToSubmit: '',
                placeholder:'添加一条留言'
            };
            
            getReviewList(true);
            
            $scope.doReply = function(name,cid){
                //$ionicScrollDelegate.$getByHandle("doctor-scroll-detail").scrollTo(0,angular.element('#doctorReviewMessage').position().top,true);
                $ionicScrollDelegate.$getByHandle("column-scroll").scrollBottom($('#columnReviewMessage').offset().top>document.documentElement.clientHeight);
                $scope.reviewInfo.placeholder = '@'+name+':';
                $scope.reviewInfo.parentId = cid;
                $timeout(function(){cordova.plugins.Keyboard.close();},300);
            }
            
            $scope.dontReply = function(){
                $scope.reviewInfo.placeholder = '添加一条留言';
                $scope.reviewInfo.parentId = '';
                cordova.plugins.Keyboard.close();
            }
            $scope.submitReview = function () {
                if (!$scope.reviewInfo.reviewToSubmit.length) {
                $ionicLoading.show({
                                   template: '留言不能为空'
                                   });
                return;
            }
         
            //先批量上传图后再提交评论
            var promises = $scope.picUrls.map(function(url) {
                  return  $cordovaFileTransfer.upload(
                                                      'http://missxiaohua.com/rest/file/upload',
                                                      url, {
                                                      encodeURI:true,
                                                      timeout:5000,
                                                      fileName:'image'+parseInt(Math.random()*100000)+'.jpg',
                                                      mimeType:"image/jpeg"
                                                      });
                  });
            
            $q.all(promises).then(function(results) {
                                  var imageList = $("<div class='comment-image-list'></div>");
                                  if(results.length>0){
                                         results.forEach(function(i){
                                                    console.log(JSON.parse(i.response).obj)
                                                  imageList.append($("<div class='comment-image'><img src='" + JSON.parse(i.response).obj + "'></div>"));
                                                  })
                                        imageList = imageList.prop("outerHTML");
                                  }else{
                                  imageList = ''
                                  }
                                  console.log(imageList)
                                  $http.post('http://missxiaohua.com/rest/column_comment/add',  {
                                             reqStr: JSON.stringify({
                                                columnId: columnId,
                                                content: ($scope.reviewInfo.placeholder=='添加一条留言'?'':$scope.reviewInfo.placeholder)+$scope.reviewInfo.reviewToSubmit+imageList,
                                                parentId:$scope.reviewInfo.parentId
                                                })
                                             }).then(function (response) {
                                                     response = response.data;
                                                     if (response.code === '200') {
                                                     $ionicLoading.show({
                                                                        template: '留言提交成功'
                                                                        });
                                                     getReviewList(false);
                                                     $scope.reviewInfo.reviewToSubmit = '';
                                                     }else if(500 == result.code){
                                                     localStorage.hasLogin = true;
                                                     $state.go('login');
                                                     }else{
                                                     $ionicLoading.show({
                                                                        template: '留言失败'
                                                                        })
                                                     }
                                                     });
                                  
                                  })
            };
            
            $scope.getQuote = function(parentId){
            var arr = $scope.reviewInfo.reviewList;
            for(var i=0;i<arr.length;i++){
            if(parentId == arr[i].commentId){
            var cont = arr[i].content;
            if(arr[i].content.indexOf('<div class="comment-image-list">')!=-1){
            cont = arr[i].content.split('<div class="comment-image-list">')[0];
            }
            return {
            quoteName:arr[i].nickName,
            quoteCont:cont
            }
            break;
            }
            
            }
            }
            
            //评论大图预览
            var slideHandle = $ionicSlideBoxDelegate.$getByHandle('doctor-comment-slide');
                $scope.bigImageSrcs = [];
                $scope.isBigShown = false;
                $scope.showBigImage = function(idx,srcs){
                $scope.isBigShown = true;
                $scope.bigImageSrcs = [];
                srcs.forEach(function(src){
                         $scope.bigImageSrcs.push(src.split('.jpg')[0]+'.jpg');
                         })
            // slideHandle.slide(idx);
            // slideHandle.update();
            }
            
            $scope.hideBigImage = function(){
               $scope.isBigShown = false;
               $scope.bigImageSrcs = [];
            }
            
            function getReviewList(flag) {
               $http.get('http://missxiaohua.com/rest/column_comment/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             columnId: columnId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              response.data.obj.forEach(function (item) {
                                    var headImgUrl = Utils.getStyledImageUrl(item.headImgUrl, {width: 60, height: 60});
                                    item.headImgUrl = headImgUrl || 'img/default_user_head.png';
                                    if(item.content.indexOf('comment-image-list')!=-1){
                                    item.contentMain = item.content.split('<div class="comment-image-list">')[0];
                                    item.imgsrcs = item.content.split('<div class="comment-image"><img src="').slice(1);
                                    }else{
                                    item.contentMain = item.content;
                                    item.imgsrcs = null;
                                    }
                                    
                                    item.short = true;
                                    item.isUserReported = false;


                                    });
                              
                              $scope.reviewInfo.reviewList = response.data.obj;
                              $scope.reviewInfo.reviewList.isUserReported = false;
                              $scope.reviewInfo.showAllReview = !flag;
                              
                              //定位到评论
                              $scope.$applyAsync(function () {
                                                 if(flag&&stateCid){
                                                 if(angular.element('.columnView .reviews>dl.doctor-comment'+stateCid).position().top == 0){
                                                    $scope.reviewInfo.showAllReview = true;
                                                 }
                                                 $timeout(function() {
                                                          $ionicScrollDelegate.$getByHandle("column-scroll").scrollTo(0,angular.element('.columnView .reviews>dl.doctor-comment'+stateCid).position().top,true);
                                                          }, 400);
                                                 };
                                                 });
                              }else if('453' == response.data.code ){
                              $state.go('login');
                              }
                              else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            }
            

            })


angular.module('starter')
.controller('CouponListCtrl', function ($scope, $http) {
            $scope.fetchCouponListStatus = 'loading';
            $scope.couponList = [];
            $http.get('http://missxiaohua.com/rest/user/coupon_list', {
                      params: {
                        reqStr: JSON.stringify({})
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              $scope.fetchCouponListStatus = 'success';
                              response.data.obj.forEach(function(item){
                                     item.flags =  parseInt(item.flags);
                                     $scope.couponList.push(item)
                             })
                             // $scope.couponList = response.data.obj;
                              }
                              else {
                              $scope.fetchCouponListStatus = 'fail';
                              }
                              }, function () {
                              $scope.fetchCouponListStatus = 'fail';
                              });
            });

angular.module('starter')
.controller('DoctorDetailCtrl', function ($scope, $stateParams, $http, $ionicLoading, $ionicSlideBoxDelegate,Utils, $state,  $ionicScrollDelegate, $cordovaFileTransfer,$q, $timeout, $ionicPopup) {
            var doctorId = $stateParams.doctorId;
            var stateCid = $stateParams.commentId;
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            
            $scope.portraitUrl = 'img/doctor_hospital/doctor_head_default.png';
            
            $scope.doctorInfo = {};
            $scope.introductionInfo = {
               showAll: false
            };
            
            //上传评论图片
            $scope.picUrls = [];
            $scope.uploadPic = function () {
            // angular.element('#head-image-input').click();
            var options = {
                destinationType: Camera.DestinationType.FILE_URI,
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                saveToPhotoAlbum: true,
                targetWidth: 800,
                targetHeight: 800
            };
            
            //Camera.getPicture(type)->根据选择的“选取图片”的方式进行选取
            if($scope.picUrls.length<3){
               navigator.camera.getPicture(function (imageURI) {
                                        // $scope.me.image = imageURI;
                                        //更新页面上的照片
                                        $scope.picUrls.push(imageURI);
                                        $scope.$apply();
                                        }, function (error) {
                                        //error handle
                                        console.log("Error: " + error);
                                        }, options);
            }else{
               $ionicLoading.show({
                               template: "最多支持上传三张"
                               });
            
            }
            };
            
            $scope.removePic = function (key) {
               $scope.picUrls.splice(key, 1);
            }
            
            //评论点赞
            $scope.praiseComment = function(flag,commentId,idx) {
            
            if (flag != null) {
            return;
            }
            
            $http.get('http://missxiaohua.com/rest/doctor_comment/praise', {
                      params: {
                         reqStr: JSON.stringify({commentId: commentId})
                      }
                      }).then(function(result){
                              result = result.data;
                              if (200 != result.code) {
                              $ionicLoading.show({
                                   template: '服务器错误,'+result.msg
                                 });
                              }
                              $scope.reviewInfo.reviewList[idx].isUserPraised = true;
                              $scope.reviewInfo.reviewList[idx].praiseCount+= 1;
                              
                              })
            }
            
            //举报
            $scope.reportComment=function(flag, commentId, idx) {
                if (flag) {
                return;
                }
                
                var popup = $ionicPopup.show({
                                         title: '评论举报',
                                         template: '<p style="font-size:14px;">确定要举报此内容</p>',
                                         scope: $scope,
                                         buttons: [{
                                                   text: '取消',
                                                   onTap: function(e) {
                                                   popup.close();
                                                   }
                                                   },{
                                                   text: '确认',
                                                   onTap: function(e) {
                                                   $http.get('http://missxiaohua.com/rest/doctor_comment/report', {
                                                             params: {
                                                             reqStr: JSON.stringify({commentId: commentId})
                                                             }
                                                             }).then(function (response) {
                                                                     if (response.data.code === '200') {
                                                                     var resultPopup = $ionicPopup.alert({
                                                                         title: '举报成功',
                                                                         cssClass:'no-btns',
                                                                         template: '<p style="font-size:12px;padding-bottom:12px;">感谢您加入我们来共同维护平台环境，我们会马上对此评论进行严格审核</p>'
                                                                                                         });
                                                                     $scope.reviewInfo.reviewList[idx].isUserReported = true;
                                                                     
                                                                     }
                                                                     $timeout(function(){resultPopup.close();},2000);
                                                                     })
                                                   }
                                                   }]
                                         });
            
            
            }


            $http.get('http://missxiaohua.com/rest/doctor/one', {
                      params: {
                      reqStr: JSON.stringify({
                                             doctorId: doctorId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var resultObj = response.data.obj;
                              if (resultObj.portraitUrl) {
                              $scope.portraitUrl = resultObj.portraitUrl;
                              }
                              
                              $scope.doctorInfo.name = resultObj.name;
                              $scope.doctorInfo.title = resultObj.title;
                              $scope.doctorInfo.hospitalName = resultObj.hospitalName;
                              $scope.doctorInfo.hospitalId = resultObj.hospitalId;
                              $scope.doctorInfo.introduction = resultObj.introduction || '暂无';
                              $scope.doctorInfo.isAuthenticated = resultObj.isAuthenticated;
                              $scope.doctorInfo.score = resultObj.score;
                              $scope.doctorInfo.specificAreas = resultObj.specificAreas ?
                              resultObj.specificAreas.split(/,|，|;|；|、/, 4) : ['整容'];
                              
                              $scope.$applyAsync(function () {
                                                 var $introduction = $('#doctor_introduction');
                                                 var lineHeight = parseInt($introduction.css('lineHeight'));
                                                 var lines = $introduction.height() / lineHeight;
                                                 
                                                 $scope.introductionInfo.lines = lines;
                                                 $scope.introductionInfo.lineHeight = lineHeight;
                                                 });
                              
                              }
                              else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            
            $scope.jumpToHospital = function (hospitalId) {
                $state.go('content.hospitalDetail', {
                      hospitalId: hospitalId
                      });
            };
            
            $scope.sales = [];
            $http.get('http://missxiaohua.com/rest/project/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             doctorId: doctorId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              response.data.obj.forEach(function (item) {
                                        item.coverPicUrl = item.pics.split(',')[0];
                                        //item.coverPicUrl = Utils.getStyledImageUrl(item.coverPicUrl, {width: 132, height: 106});
                                        item.url = '#'; //link_adress
                                        $scope.sales.push(item);
                                        });
                              }
                              else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            
            $scope.reviewInfo = {
                reviewList: [],
                showAllReview: '',
                reviewToSubmit: '',
                placeholder:'添加一条留言'
            };
            
            getReviewList(true);
            
            $scope.doReply = function(name,cid){
                if($('#doctorReviewMessage').offset().top>document.documentElement.clientHeight)
                   $ionicScrollDelegate.$getByHandle("doctor-scroll-detail").scrollTo(0,angular.element('#doctorReviewMessage').position().top,true);
                   //$ionicScrollDelegate.$getByHandle("doctor-scroll-detail").scrollBottom($('#doctorReviewMessage').offset().top>document.documentElement.clientHeight);
                    $scope.reviewInfo.placeholder = '@'+name+':';
                    $scope.reviewInfo.parentId = cid;
                    $timeout(function(){cordova.plugins.Keyboard.close();},300);
            }
            
            $scope.dontReply = function(){
                $scope.reviewInfo.placeholder = '添加一条留言';
                $scope.reviewInfo.parentId = '';
                cordova.plugins.Keyboard.close();
            }
            $scope.submitReview = function () {
                if (!$scope.reviewInfo.reviewToSubmit.length) {
                    $ionicLoading.show({
                            template: '留言不能为空'
                    });
                    return;
                }
            
            //先批量上传图后再提交评论
            var promises = $scope.picUrls.map(function(url) {
                                              
                  return  $cordovaFileTransfer.upload(
                          'http://missxiaohua.com/rest/file/upload',
                          url, {
                          encodeURI:true,
                          timeout:5000,
                          fileName:'image'+parseInt(Math.random()*100000)+'.jpg',
                          mimeType:"image/jpeg"
                          });
                  });
            
                 $q.all(promises).then(function(results) {
                                  var imageList = $("<div class='comment-image-list'></div>");
                                  if(results.length>0){
                                  results.forEach(function(i){
                                                  imageList.append($("<div class='comment-image'><img src='" + JSON.parse(i.response).obj + "'></div>"));
                                                  })
                                  imageList = imageList.prop("outerHTML");
                                  }else{
                                  imageList = ''
                                  }
                                       
                                       
                               $http.post('http://missxiaohua.com/rest/doctor_comment/add',  {
                                          reqStr: JSON.stringify({
                                             doctorId: doctorId,
                                             content: ($scope.reviewInfo.placeholder=='添加一条留言'?'':$scope.reviewInfo.placeholder)+$scope.reviewInfo.reviewToSubmit+imageList,
                                             parentId:$scope.reviewInfo.parentId
                                          })
                                          }).then(function (response) {
                                                  response = response.data;
                                              if (response.code === '200') {
                                                  $ionicLoading.show({
                                                                     template: '留言提交成功'
                                                                     });
                                                  getReviewList(false);
                                                  $scope.reviewInfo.reviewToSubmit = '';
                                                  }else if(500 == result.code){
                                                  localStorage.hasLogin = true;
                                                  $state.go('login');
                                                  }else{
                                                  $ionicLoading.show({
                                                                 template: '留言失败'
                                                                 })
                                              }
                                            });

                })
           };
            
            $scope.getQuote = function(parentId){
               var arr = $scope.reviewInfo.reviewList;
               for(var i=0;i<arr.length;i++){
                    if(parentId == arr[i].commentId){
                    var cont = arr[i].content;
                    if(arr[i].content.indexOf('<div class="comment-image-list">')!=-1){
                      cont = arr[i].content.split('<div class="comment-image-list">')[0];
                    }
                    return {
                        quoteName:arr[i].nickName,
                        quoteCont:cont
                    }
                      break;
                    }
            
                }
            }
            
            //评论大图预览
            var slideHandle = $ionicSlideBoxDelegate.$getByHandle('doctor-comment-slide');
            $scope.bigImageSrcs = [];
            $scope.isBigShown = false;
            $scope.showBigImage = function(idx,srcs){
                $scope.isBigShown = true;
                $scope.bigImageSrcs = [];
                srcs.forEach(function(src){
                    $scope.bigImageSrcs.push(src.split('.jpg')[0]+'.jpg');
               })
              // slideHandle.slide(idx);
              // slideHandle.update();
            }
            
            $scope.hideBigImage = function(){
                $scope.isBigShown = false;
                $scope.bigImageSrcs = [];

            }

            function getReviewList(flag) {
               $http.get('http://missxiaohua.com/rest/doctor_comment/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             doctorId: doctorId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              response.data.obj.forEach(function (item) {
                                    var headImgUrl = Utils.getStyledImageUrl(item.headImgUrl, {width: 60, height: 60});
                                    item.headImgUrl = headImgUrl || 'img/default_user_head.png';
                                    if(item.content.indexOf('comment-image-list')!=-1){
                                            item.contentMain = item.content.split('<div class="comment-image-list">')[0];
                                            item.imgsrcs = item.content.split('<div class="comment-image"><img src="').slice(1);
                                    }else{
                                        item.contentMain = item.content;
                                        item.imgsrcs = null;
                                    }
                                    
                                    item.short = true;
                              });
                              $scope.reviewInfo.reviewList = response.data.obj;
                              $scope.reviewInfo.showAllReview = !flag;
                              
                              //定位到评论
                              $scope.$applyAsync(function () {
                                if(flag&&stateCid){
                                         if(angular.element('.doctorDetailView .reviews>dl.doctor-comment'+stateCid).position().top == 0){
                                         $scope.reviewInfo.showAllReview = true;
                                         }
                                         $timeout(function() {
                                                  
                                            $ionicScrollDelegate.$getByHandle("doctor-scroll-detail").scrollTo(0,angular.element('.doctorDetailView .reviews>dl.doctor-comment'+stateCid).position().top,true);
                                            }, 400);
                                         };
                                });
                            }else if('453' == response.data.code ){
                                 $state.go('login');
                              }
                              else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            }
            
        });

angular.module('starter')
.controller('DoctorListCtrl', function ($scope, CityList, SlideDownMenu,$ionicLoading, $http, $window, $ionicScrollDelegate, Utils, $state,$stateParams,$timeout) {

            
            $scope.searchWord = $stateParams.keyword||'';
            $scope.isLoadingDoctorList = true;
            $scope.orderTypes = [{name: "默认", value: ""}];
            $scope.orderTypeDefault = "默认";
            $scope.provinces = CityList;
            $scope.cityDefault = "全国";
            $scope.searchActive = false;
            $scope.activeSearch = function(){
               $scope.searchActive = true;
               cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
               //angular.element('.search-input').focus();
            }
            $scope.deactiveSearch = function(){
               if($scope.searchWord!=''){
                     $scope.searchWord = '';
                     initListStatus();
                     loadDoctorList();
                     oldWord = '';
                }
               cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
               $timeout(function(){cordova.plugins.Keyboard.close();1000})
            }
            
            
            var oldWord = '';
            $scope.search = function(word){
              // $scope.searchActive = true;
              if(word!=''&&word!=oldWord){
                   oldWord = word;
                   var reg = /[\u4E00-\u9FA5\uF900-\uFA2D]/;
                    if(reg.test(word)){
                        initListStatus();
                        //loadSearchList();
                        loadDoctorList();
                        $timeout(function(){cordova.plugins.Keyboard.close();1000})
                   }else{
                        $ionicLoading.show({template:'请输入正确医生姓名'})
                   }
              }
            }
            
            $timeout(function(){
                     $http.get('http://missxiaohua.com/rest/category/list', {
                               reqStr: JSON.stringify({
                                                      level: 0
                                                      })
                               }).then(function (response) {
                                       if (response.data.code === '200') {
                                       var mainCategories = response.data.obj;
                                       for (var i = 0; i < mainCategories.length; ++i) {
                                       $scope.orderTypes.push({name: mainCategories[i].name, value: "categoryId:" + mainCategories[i].categoryId});
                                       }
                                       }else {
                                       // fail
                                       }
                                       }, function () {
                                       // fail
                                       });
                     

                     },1000)
            $scope.toDoctorDetail = function (doctorId) {
                  $state.go('content.doctorDetail', {
                      doctorId: doctorId
                      });
            };
            
            // Interface parameters.
            var name = null;
            var specificAreas = null;
            var hospitalId = null;
            var isAuthenticated = null;
            var title = null;
            var pageNo = 1;
            var previousPageNo = 0;
            var pageSize = 0;
            var city = null;
            var province = null;
            var orderBy = null;
            var order = null;
            var categoryId = null;
            
            var hasMoreData = true;
            
            var initListStatus = function() {
                pageNo = 1;
                pageSize = 6;
                previousPageNo = pageNo - 1;
                hasMoreData = true;
               // SlideDownMenu.setValue('doctor-order-type','');
               // SlideDownMenu.setValue('doctor-city-filter','全国')
                $scope.items = [];
            };
            
            initListStatus();
            
            
            var renderDoctorList = function(objArray){
                updatePageInfo(objArray)
                for (var index = 0; index < objArray.length; index++) {
                var isAuth = objArray[index].isAuthenticated == 0 ? "nauth.png" : "oauth.png";
                var starStr = "";
                for (var i=0; i<5; i++) {
                if (objArray[index].score != "" && objArray[index].score != undefined) {
                if (i<objArray[index].score) {
                starStr += "<img src='img/star-red.png'/>";
                }
                else {
                starStr += "<img src='img/star-white.png'/>";
                }
                }
                }
                var spAreasArry = Utils.getSpecificAreas(objArray[index].specificAreas);
                var portraitUrl = (null == objArray[index].portraitUrl) ? "" : objArray[index].portraitUrl;
                portraitUrl = Utils.getStyledImageUrl(portraitUrl, {width: 80, height: 80});
                portraitUrl = ("" == portraitUrl) ? "img/doctor_hospital/doctor_head_default.png" : portraitUrl;
                $scope.items.push({
                                  id: index,
                                  doctorId: objArray[index].doctorId,
                                  doctorName: objArray[index].name,
                                  doctorTitle: objArray[index].title,
                                  doctorHospital: objArray[index].hospitalName,
                                  hospitalId: objArray[index].hospitalId,
                                  doctorStar: starStr,
                                  doctorAuth: isAuth,
                                  doctorSpecificAreas: spAreasArry,
                                  portraitUrl: portraitUrl
                                  });
                }
               $scope.isLoadingDoctorList = false;
            }
            
            var updatePageInfo = function(objArray) {
                if (null == objArray || objArray.length < pageSize) {
                hasMoreData = false;
                return;
                }
                $timeout(function() {++pageNo;}, 1000);
            };
            
            var loadDoctorList = function() {
            console.log('loaddoctorlist')
                var params = {
                    name: $scope.searchWord,
                    specificAreas: specificAreas,
                    hospitalId: hospitalId,
                    isAuthenticated: isAuthenticated,
                    title: title,
                    page: pageNo,
                    size: pageSize,
                    city: city,
                    province: province,
                    categoryId: categoryId,
                    orderBy: orderBy,
                    order: order
                };
            
                // To avoid the ion-infinite-scroll call twice bug.
                // See http://forum.ionicframework.com/t/on-infinite-called-twice-when-using-ion-infinite-scroll/5216
                //     http://stackoverflow.com/questions/27359867/infinite-scrolling-with-http-get-firing-twice
                if (pageNo == previousPageNo) {
                   console.log("Reload doctor reentered.");
                  return;
                }
                previousPageNo = pageNo;
                
                $http.get('http://missxiaohua.com/rest/doctor/list', {
                  params: {
                      reqStr: params
                  }
                  }).then(function (response) {
                      if (response.data.code === '200') {
                        renderDoctorList(response.data.obj)
                      }else {
                      // fail
                      }
                      }).finally(function () {
                         $scope.isLoadingDoctorList = false;
                     });
            };
            
            $scope.loadMore = function() {
                loadDoctorList();
            // Fix the bug. See http://forum.ionicframework.com/t/resolved-issue-beta-14-ion-infinite-scroll-keep-on-calling-the-method-of-on-infinite/14301
            //          $scope.$broadcast('scroll.infiniteScrollComplete');
                 $scope.$broadcast('scroll.infiniteScrollComplete');
            }
            
            $scope.moreDataCanBeLoaded = function() {
            return hasMoreData;
            };
            
            $scope.toggleCanSwipe = function() {
            $ionicListDelegate.canSwipeItems(!$scope.canSwipe());
            };
            
            $scope.canSwipe = function() {
            return $ionicListDelegate.canSwipeItems();
            };
            
            $scope.data = {
            showDelete: false
            };
            
            var onOrderTypeChanged = function(newVal, oldVal, scope) {
            if (null == newVal) {
            return;
            }
            
            orderBy = newVal;
            order = "desc";
            // Select the default.
            if ("" == orderBy) {
            orderBy = null;
            order = null;
            categoryId = null;
            }
            // Filter by main category.
            else if (/categoryId:.*/.test(orderBy)) {
            categoryId = (orderBy.split(":"))[1];
            orderBy = "mainCategoryFlag";
            order = "desc";
            }
            else {
            orderBy = null;
            order = null;
            categoryId = null;
            }
            initListStatus();
            loadDoctorList();
            $ionicScrollDelegate.$getByHandle("doctor-scroll-list").scrollTop();
            }
            
            var onCityFilterChanged = function (newVal, oldVal, scope) {
                if (null == newVal) {
                  return;
                }
                var idxColon = newVal.indexOf(":");
                if (-1 == idxColon) {
                    // Only the “全国” situation is valid.
                    if ("全国" == newVal) {
                        province = null;
                        city = null;
                    }else {
                       return;
                    }
                }else {
                  // province:city
                  province = newVal.substring(0, idxColon);
                  city = newVal.substring(idxColon + 1);
                }
                initListStatus();
                loadDoctorList();
                $ionicScrollDelegate.$getByHandle("doctor-scroll-list").scrollTop();
            }
            
            SlideDownMenu.watch($scope, "doctor-order-type", onOrderTypeChanged);
            SlideDownMenu.watch($scope, "doctor-city-filter", onCityFilterChanged);
            });

angular.module('starter')
.controller('FindProjectCtrl', function ($scope, $location, $http) {
            
            $scope.listPage = 1;
            $scope.listPageSize = 6;
            
            $http.get('http://missxiaohua.com/rest/category/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             level: 0
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var mainCategories = response.data.obj;
                              var order = ["注射","眼部","鼻部","美肤","抗衰","面部","胸部","瘦身","其他"];
                              var k = 0;
                              $scope.mainCategories = [];
                              for (var i = 0; i < order.length; ++i) {
                              for (var j = 0; j < mainCategories.length; ++j) {
                              if (order[i] === mainCategories[j].name) {
                              $scope.mainCategories[k++] = mainCategories[j];
                              break;
                              }
                              }
                              }
                              if ($scope.mainCategories.length > 0) {
                              $scope.onMainCategoryClick(0);
                              }
                              }
                              });
            
            $scope.onMainCategoryClick = function ($index) {
            var categoryId = $scope.mainCategories[$index].categoryId;
            
            $http.get('http://missxiaohua.com/rest/category/list', {
                      params: {
                      reqStr: JSON.stringify({
                           parentCategoryId: categoryId
                         })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var subCategories = response.data.obj;
                              var countPerLine = 3;
                              $scope.subCategories = [];
                              for(var i = 0; i < subCategories.length; i = i + countPerLine) {
                              $scope.subCategories[i / countPerLine] = [];
                              var countCurLine = countPerLine;
                              for (var j = i; j < i + countPerLine && j < subCategories.length; ++j) {
                              $scope.subCategories[i / countPerLine][j - i] = subCategories[j];
                              }
                              }
                              }
                              });
            }
            });
angular.module('starter')
.controller('EventListCtrl', function ($scope,$state,$stateParams,$http,Utils) {
        $scope.eventList = [];
        var type = $scope.columnType = $stateParams.column_type;
        $scope.gotoColumn = function(columnId){
            $state.go('content.column', {
                      columnId: columnId
                      });
            }
        if(type){
        // 1: 科普   2:八卦
        $http.get("http://missxiaohua.com/rest/special_column/list", {
            params:{reqStr: JSON.stringify({type: type})}}).then(function (response) {
            response.data.obj.forEach(function(item){
                 item.picUrl = item.pictures;
                 item.title = item.name;
                 $scope.eventList.push(item);
                 })
           });
        }else{
            $http.get('http://missxiaohua.com/rest/link/list', {
                      params: {
                      reqStr: JSON.stringify({type: 1})
                      }
                      }).then(function (response) {
                              response.data.obj.forEach(function(item){
                                   item.columnId = item.href.split('columnId=')[1];
                                   $scope.eventList.push(item);
                                })
                              $http.get('http://missxiaohua.com/rest/link/list', {
                                        params: {
                                        reqStr: JSON.stringify({type: 2})
                                        }
                                        }).then(function (response) {
                                                response.data.obj.forEach(function(item){
                                                          item.columnId = item.href.split('columnId=')[1];
                                                          $scope.eventList.push(item);
                                                      })
                                                })
                              })
        }

})
angular.module('starter')
.controller('MessageListCtrl', function ($scope, $state,$http) {
            $scope.messageList = [];
            $scope.gotoMessage = function(cid,columnId,doctorId){
               $http.get('http://missxiaohua.com/rest/mc/markRead' ,{
                       params: {
                          reqStr: {
                             commentId:cid,
                             columnId:columnId,
                             doctorId:doctorId
                          }
                       }
                       }).then(function (response) {
                           localStorage.messagNum -= 1;
                           if(columnId){
                               $state.go('content.column', {
                                    columnId: columnId,
                                    commentId:cid
                               });
                           }
                           if(doctorId){
                           $state.go('content.doctorDetail', {
                                     doctorId: doctorId,
                                     commentId:cid
                                     });
                           }
              })
            }
            $http.get('http://missxiaohua.com/rest/mc/list').then(function (response) {
                      if(response.data.code=='200'){
                              response.data.obj.forEach(function(item){
                                item.nickName = item.nickName||item.phone;
                                item.headImgUrl = item.headImgUrl||'img/default_user_head.png';
                                $scope.messageList.push(item);
                             });
                      }else{
                         alert('消息列表获取失败')
                      }
              })
})
angular.module('starter')
.controller('HomeCtrl', function ($scope, $http, Utils, $ionicSlideBoxDelegate, $state,$timeout,$ionicNavBarDelegate,$ionicLoading) {

            if(localStorage.authTocken){
               $http.get('http://missxiaohua.com/rest/user/info', {
                      params: {
                      time: new Date().getTime()
                      }
                      }).then(function (response) {
                              if(response.data.code=='200'){
                              localStorage.userId = response.data.obj.userId;
                              $rootScope.setPushAlias(localStorage.userId)
                              gotostate();
                              }else{
                                 localStorage.authTocken = null;
                                 $state.go('login');
                              }
                              })
            }
            
            
            $scope.jumpToUserCenter = function () {
                $state.go('content.userCenter.index');
           //  $state.go('content.consult');
            };
            $scope.jumpToProjectList= function (_url) {
               $state.go('content.projectList',{
                      subCategoryName:Utils.getQueryString('subCategoryName',_url),
                      subCategoryId:Utils.getQueryString('subCategoryId',_url)
                      });
            };
            
            $scope.jumpToProject = function(projectId) {
                //$cookieStore.put("projectId", projectId);
                if (!projectId) {
                return;
                }
                $state.go('content.projectDetail', {
                          projectId: projectId
                          });
                
                };
                $scope.jumpToColumn = function(cId) {
                //$cookieStore.put("projectId", projectId);
                if (!cId) {
                return;
                }
                $state.go('content.column', {
                          columnId: cId
                          });
            
            };
            
            // 加载特惠列表
            $scope.preferentialStatus = 'loading';

            $http.get('http://missxiaohua.com/rest/preferential/list', {
                      params: {
                      reqStr: {}
                      }
                      }).then(function (response) {
                              var preferentials = response.data.obj;
                              
                              if (response.data.code === '200') {
                              $scope.preferentialStatus = 'success';
                              
                              $scope.firstPreferential = null;
                              $scope.lastPreferential = null;
                              $scope.middlePreferentials = null;
                              
                              if (!preferentials) {
                              return;
                              }
                              
                              var imageSize = Utils.getElementSize(".pref-price");
                              if (preferentials.length >= 1) {
                                 $scope.firstPreferential = preferentials[0];

                              }
                              if (preferentials.length >= 2) {
                              $scope.lastPreferential = preferentials[preferentials.length - 1];
                              $scope.lastPreferential.picture = Utils.getStyledImageUrl(
                                        $scope.lastPreferential.picture,
                                        imageSize
                                        );
                              }
                              if (preferentials.length >= 3) {
                              $scope.middlePreferentials = preferentials.slice(1, preferentials.length - 1);
                             
                              }
                              }
                              else {
                              $scope.preferentialStatus = 'error';
                              }
                              }, function () {
                              $scope.preferentialStatus = 'error';
                              });
            
            
            // 主页轮播图
            var slideHandle = $ionicSlideBoxDelegate.$getByHandle('home-ad-slide');
            
            $scope.pagerClick = function(index) {
            slideHandle.slide(index);
            };
            
            $http.get('http://missxiaohua.com/rest/link/list', {
                      params: {
                      reqStr: JSON.stringify({type: 1})
                      }
                      }).then(function (response) {
                              var bannerArry = response.data.obj || [];
                              for (var i = 0; i < bannerArry.length; ++i) {
                              bannerArry[i].href = Utils.getActivityUrl(bannerArry[i].href);
                              bannerArry[i].picUrl = bannerArry[i].picUrl;
                              }
                              $scope.bannerArry = bannerArry;
                              $timeout(function() { angular.element('.slider-pager').show();angular.element('.loading-backdrop').hide();}, 400);
                              });
            
            // 活动页轮播图
            var activityPagerClick = $ionicSlideBoxDelegate.$getByHandle("activity-slide");
            $scope.clickArrowRight = function() {
            activityPagerClick.next();
            };
            
            $scope.clickArrowLeft = function() {
            activityPagerClick.previous();
            };
            
            $scope.activityPagerClick = function(index) {
            activityPagerClick.slide(index);
            };
            
            $http.get('http://missxiaohua.com/rest/link/list', {
                      params: {
                      reqStr: JSON.stringify({type: 2,start:1,size:6})
                      }
                      }).then(function (response) {
                              var activityArray = response.data.obj || [];
                              for (var i = 0; i < activityArray.length; ++i) {
                              activityArray[i].href = Utils.getActivityUrl(activityArray[i].href);
                              /*activityArray[i].picUrl = Utils.getStyledImageUrl(
                               activityArray[i].picUrl,
                               {width: Math.floor(window.innerWidth * 1.5)}
                               );*/
                              }
                              $scope.activityArray = activityArray;
                              $timeout(function() { angular.element('.slider-pager').show();}, 1000);
                              
                              });
            
            // 小花科普
            $http.get('http://missxiaohua.com/rest/special_column/list', {
                      params: {
                      reqStr: JSON.stringify({type: 1,isValid:true})
                      }
                      }).then(function (response) {
                              var result = response.data;
                              if (result.code === '200') {
                              $scope.scip = result.obj;
                              
                              }
                              });
            
            // 整形八卦
            $http.get('http://missxiaohua.com/rest/special_column/list', {
                      params: {
                      reqStr: JSON.stringify({type: 2,isValid:true})
                      }
                      }).then(function (response) {
                              var result = response.data;
                              if (result.code === '200') {
                              $scope.gossip = result.obj;
                              }
                              });
            
            // 更多优惠
            $http.get('http://missxiaohua.com/rest/link/list', {
                      params: {
                      reqStr: JSON.stringify({type: 3})
                      }
                      }).then(function (response) {
                              $scope.timingSales = response.data.obj || [];
                              var picWidth = Math.floor(window.innerWidth / 3);
                              });
            //消息提醒
            $scope.showTip = false;
            var msgtimer;
            $scope.messagNum = localStorage.messagNum;
            function refreshMessage(){
                  $http.get('http://missxiaohua.com/rest/mc/list').then(function (response) {
                     $scope.messagNum = localStorage.messagNum  = parseInt(response.data.obj.length);
                     $scope.showTip = ($scope.messagNum>0);
                  });
                  $timeout(function() {$scope.showTip = false; }, 5000);
            }
            $scope.$on('$ionicView.afterEnter',function(){
                $scope.messagNum = localStorage.messagNum;
                $timeout(function() { refreshMessage();}, 3000);
                msgtimer = setInterval(function() {
                            refreshMessage();
                        },180000);
            })
            $scope.$on('$ionicView.leave',function(){
                    clearInterval(msgtimer)
                       })
            
            //search
            $scope.isSearchShown = false;
            function deactiveSearch (){
                $ionicNavBarDelegate.title('首页');
                $scope.isSearchShown = false;
                $scope.searchWord = '';
                $timeout(function(){cordova.plugins.Keyboard.close()},500)
            }
            $scope.doSearch = function () {
                $scope.isSearchShown = true;
                $ionicNavBarDelegate.title('');
            }
            $scope.search = function(word){
                var reg = /[\u4E00-\u9FA5\uF900-\uFA2D]/;
                if(reg.test(word)){
                   $state.go('content.search', {
                          keyword:word
                    });
                $scope.isSearchShown = false;
                   //$timeout(function(){ deactiveSearch ()},1000)
            
                }else{
                   $ionicLoading.show({template:'请输入医生或项目名称'})
                }
            }
            $scope.deactiveSearch = function(){
                deactiveSearch ();
            }
            
});
angular.module('starter')
.controller('SearchCtrl', function ($scope, $http,$state, $stateParams,Utils,$timeout,$q) {
    
        var keyword = $stateParams.keyword;
        
            $scope.searchWord = keyword;
            $scope.doctors = [];
            $scope.projectsList = [];
            $scope.forSale  = false;
            $scope.noresult = false;
        $scope.toDoctorDetail = function (doctorId) {
            $state.go('content.doctorDetail', {
                      doctorId: doctorId
                      });
            };
        $scope.onClickProject = function ($index) {
            $state.go('content.projectDetail', {
                      projectId: $scope.projectsList[$index].projectId
                      });
            };
        var loadDoctorList = function() {
            var params = {
                name: $scope.searchWord
            };
            $http.get('http://missxiaohua.com/rest/doctor/list', {
                      params: {
                      reqStr: {"name":$scope.searchWord,"page":1,"size":3}
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var objArray = response.data.obj;
                              for (var index = 0; index < objArray.length; index++) {
                              var isAuth = objArray[index].isAuthenticated == 0 ? "nauth.png" : "oauth.png";
                              var starStr = "";
                              for (var i=0; i<5; i++) {
                              if (objArray[index].score != "" && objArray[index].score != undefined) {
                              if (i<objArray[index].score) {
                                  starStr += "<img src='img/star-red.png'/>";
                              }
                              else {
                                  starStr += "<img src='img/star-white.png'/>";
                              }
                              }
                              }
                              var spAreasArry = Utils.getSpecificAreas(objArray[index].specificAreas);
                              var portraitUrl = (null == objArray[index].portraitUrl) ? "" : objArray[index].portraitUrl;
                              portraitUrl = Utils.getStyledImageUrl(portraitUrl, {width: 80, height: 80});
                              portraitUrl = ("" == portraitUrl) ? "img/doctor_hospital/doctor_head_default.png" : portraitUrl;
                              $scope.doctors.push({
                                                  id: index,
                                                  doctorId: objArray[index].doctorId,
                                                  doctorName: objArray[index].name,
                                                  doctorTitle: objArray[index].title,
                                                  doctorHospital: objArray[index].hospitalName,
                                                  hospitalId: objArray[index].hospitalId,
                                                  doctorStar: starStr,
                                                  doctorAuth: isAuth,
                                                  doctorSpecificAreas: spAreasArry,
                                                  portraitUrl: portraitUrl
                                                  });
                              }
                              
                              }else {
                              // fail
                              }
                              }).finally(function () {
                                         $scope.isLoadingDoctorList = false;
                                         loadProjectsList();
                              });
            };

            var projectXHR = function(param){
                var deferred = $q.defer();
                $http.get('http://missxiaohua.com/rest/project/list', {
                      params: {
                          reqStr: param
                      }
                      }).then(function (response) {
                              if (response.data.code !== '200') {
                                  deferred.resolve(response);
                              }
                              var projectsList = response.data.obj;
                              
                              for (var i = 0; i < projectsList.length; ++i) {
                              var introduction = projectsList[i].introduction;
                              var details = projectsList[i].details;
                              if (null == introduction || "" == introduction) {
                              if (null != details && "" != details) {
                              projectsList[i].introduction = details;
                              }
                              }
                              if (null == details || "" == details) {
                              if (null != introduction && "" != introduction) {
                              projectsList[i].details = introduction;
                              }
                              }
                              
                              // The coverPicUrl was deprecated.
                              if (null == projectsList[i].coverPicUrl) {
                              var pics = projectsList[i].pics.split(",");
                              if (pics.length >= 1) {
                              projectsList[i].coverPicUrl = pics[0];
                              }
                              }
                              
                              if (projectsList[i].isAuthenticated) {
                              projectsList[i].authenticate_url = "img/project/project_list/authenticate_yes.png";
                              }
                              else {
                              projectsList[i].authenticate_url = "img/project/project_list/authenticate_no.png";
                              }
                              
                              $scope.projectsList.push(projectsList[i]);
                              }
                              
                              deferred.resolve(response);
                        })
       
                     return deferred.promise;
                              
            }
             var loadProjectsList = function(){
                 projectXHR({"name": $scope.searchWord,"page":1,"size":100,"orderBy":"salesVolume","order":"desc"}).then(function(res){
                      //如果查找到唯一医生，展示其热卖项目
                      if($scope.doctors.length==1&&$scope.projectsList.length==0){
                               projectXHR({"doctorId":$scope.doctors[0].doctorId}).then(function(){
                                        $scope.forSale = true;
                                        });
                      }
                      //没有搜到任何内容
                      $scope.noresult = (($scope.projectsList.length==0)&&($scope.doctors.length==0));

                    });
            
            };
            
            loadDoctorList();
            
            
            var oldWord = '';
            $scope.search = function(word){
                if(word!=''&&word!=oldWord){
                     oldWord = word;
                    var reg = /[\u4E00-\u9FA5\uF900-\uFA2D]/;
                    if(reg.test(word)){
                        $scope.searchWord = word;
                        $scope.doctors = [];
                        $scope.projectsList = [];
                        $scope.noresult = false;
                        loadDoctorList();
                        $timeout(function(){cordova.plugins.Keyboard.close()},500);
                    }else{
                       $ionicLoading.show({template:'请输入正确医生或项目名称'})
                    }
                }
            }
            
            $scope.deactiveSearch = function(){
               $scope.searchWord = '';
               $timeout(function(){cordova.plugins.Keyboard.close();1000})
            }
            
})
angular.module('starter')
.controller('HospitalDetailCtrl', function ($scope, $http, $stateParams) {
            var hospitalId = $stateParams.hospitalId;
            $scope.hospitalInfo = {};
            $scope.introductionInfo = {
            showAll: false
            };
            $http.get('http://missxiaohua.com/rest/hospital/one', {
                      params: {
                      reqStr: JSON.stringify({
                                             hospitalId: hospitalId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var resultObj = response.data.obj;
                              $scope.hospitalInfo.name = resultObj.name;
                              $scope.hospitalInfo.qualification = resultObj.qualification || '未知等级';
                              $scope.hospitalInfo.address = resultObj.address || '无';
                              $scope.hospitalInfo.phone = resultObj.phone || '暂无';
                              $scope.hospitalInfo.noPhone = !resultObj.phone;
                              $scope.hospitalInfo.isAuthenticated = resultObj.isAuthenticated;
                              $scope.hospitalInfo.introduction = resultObj.introduction || '暂无';
                              
                              $scope.$applyAsync(function () {
                                                 var $introduction = $('#hospital_introduction');
                                                 var lineHeight = parseInt($introduction.css('lineHeight'));
                                                 var lines = $introduction.height() / lineHeight;
                                                 
                                                 $scope.introductionInfo.lines = lines;
                                                 $scope.introductionInfo.lineHeight = lineHeight;
                                                 });
                              }
                              else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            });

angular.module('starter')
.controller('ConsultCtrl', function ($scope, $http,Utils) {
            
            $scope.hasmoredata = true;
            $scope.reviewInfo = {
                reviewList: []
            };
            
            //评论大图预览
            $scope.isBigShown = false;
            $scope.showBigImage = function(src){
               $scope.isBigShown = true;
               $scope.bigImageSrc = src;
            }
            $scope.hideBigImage = function(){
               $scope.isBigShown = false;
            }
            
            var start = 0;
            $scope.loadMoreReview = function(){
               $http.get('http://missxiaohua.com/rest/doctor_comment/list', {params: {
                      reqStr: JSON.stringify({
                                             size: 10,
                                             start:start
                                             })
                      }
                      }).then(function (response) {
                          if (response.data.code === '200') {
                             if(response.data.obj.length!=0){
                                 response.data.obj.forEach(function (item) {
                                    var headImgUrl = Utils.getStyledImageUrl(item.headImgUrl, {width: 60, height: 60});
                                    item.headImgUrl = headImgUrl || 'img/default_user_head.png';
                                    item.portraitUrl = item.portraitUrl||'img/doctor_hospital/doctor_head_default.png';

                                    if(item.content.indexOf('comment-image-list')!=-1){
                                       item.contentMain = item.content.split('<div class="comment-image-list">')[0];
                                       item.imgsrcs = item.content.split('<div class="comment-image"><img src="').slice(1);
                                    }else{
                                       item.contentMain = item.content;
                                       item.imgsrcs = null;
                                    }
                                if(item.parentId != 0){
                                    if(item.parentContent.indexOf('comment-image-list')!=-1){
                                    item.parentContent = item.parentContent.split('<div class="comment-image-list">')[0];
                                    }
                                }
                                    $scope.reviewInfo.reviewList.push(item);
                                });
                           }else{
                                $scope.hasmoredata = false;
                           }
                          }else if('453' == response.data.code ){
                             $state.go('login');
                          }
                          else {
                          // fail
                          }
                           $scope.$broadcast('scroll.infiniteScrollComplete');
                  }, function () {
                  // fail
                  });
                 // $timeout(function() { start += 20;}, 1000);
                  start += 20;
            }
            
            
            $scope.$on('stateChangeSuccess', function() {
               $scope.loadMoreReview();
            });
        
            });
angular.module('starter')
.controller('LoginCtrl', function ($scope,$rootScope,$stateParams, Utils, $state,md5, User,$location, $ionicHistory, $ionicLoading,$timeout,$http) {
            $scope.formInfo = {
               tel: '',
               password: ''
            };
            $scope.isautologin = false;
            
            function setAuthAfterLogin(sid,uid){
                User.setUserInfo({
                     hasLogin: true
                });
                localStorage.authTocken = sid;
                localStorage.userId = uid;
                $rootScope.setPushAlias(localStorage.userId)
                localStorage.messagNum = 0;
            }
            
            //第三方登录：微信
            $scope.doWeixinLogin = function(){
                 Wechat.auth('snsapi_userinfo', function (response) {
                        // you may use response.code to get the access token.
                        showErrorMsg('登录验证中...');
                        $http.get('http://missxiaohua.com/rest/wechat/login?code='+response.code).then(function (response) {
                                   if(response.data.code=='200'){
                                        setAuthAfterLogin(response.data.obj.sessionid,response.data.obj.userId);
                                            $state.go('content.home');
                                   }else{
                                       showErrorMsg('登录失败，请稍后再试');
                                   }
                                   })
                        }, function (reason) {
                        showErrorMsg(reason);
                        });
            
            
            }
            //登陆注册成功后处理跳转
            var gotostate = function(){
                console.log($stateParams.page)
                console.log($stateParams.id)
                if($stateParams.page){
                    switch($stateParams.page){
                    case 'column':
                    $state.go('content.column', {
                              columnId: $stateParams.id
                              });
                    break;
                    case 'project':
                    $state.go('content.projectDetail', {
                              projectId: $stateParams.id
                              });
                    break;
                    case 'doctor':
                    $state.go('content.doctorDetail', {
                              doctorId: $stateParams.id
                              });
                    break;
                    default:
                    $state.go('content.home');
                    break;
                }
                }else{
                   $state.go('content.home');
                }
            }
            $scope.isRequesting = false;
            $scope.isRegister = !localStorage.isLogin;
            
            $scope.loginRegisterExchange = function () {
            $scope.isRegister = !$scope.isRegister;
            };
            function showErrorMsg(msg){
            $ionicLoading.show({
                               template: msg
                               });
            }
            
            $scope.submit = function () {
                var tel = $scope.formInfo.tel;
                var password = $scope.formInfo.password;
                
                if (tel.length !== 11) {
                showErrorMsg('手机号位数错误');
                return;
                }
                else if (!/^(0|86|17951)?(13[0-9]|15[012356789]|17[0-9]|18[0-9]|14[57])[0-9]{8}$/.test(tel)) {
                showErrorMsg('手机号输入错误');
                return;
                }
                else if (password.length < 6 || password.length > 18) {
                showErrorMsg('密码应为6-18位数字、字母或符号');
                return;
                }
                
                password = md5.createHash(password);
                password = md5.createHash(password);
            
            
                $scope.isRequesting = true;
            
          
                $http.post('http://missxiaohua.com/rest/user/'+($scope.isRegister?'register':'login'),  {
                       reqStr: JSON.stringify({
                                              userName: tel,
                                              password: password
                                              })
                       }).then(function (data) {
                               data = data.data;
                               if (!data) {
                               showErrorMsg('服务器错误！请稍后再试...');
                               }
                               else if (data.code === '481') {
                               showErrorMsg('手机号已注册，请直接登录');
                               }
                               else if (data.code == '482') {
                               showErrorMsg('手机号不存在');
                               }
                               else if (data.code == '483') {
                               showErrorMsg('密码错误');
                               }
                               else if (data.code === '200') {
                                   showErrorMsg($scope.isRegister?'注册成功！':'登录成功！' );
                                   localStorage.isLogin = true;
                                   //localStorage.userName = tel;
                                   //localStorage.password = password;
                                   setAuthAfterLogin(data.obj.sessionid,data.obj.userId);
                                   gotostate();
                               }
                               else {
                               showErrorMsg('失败：' + data.msg);
                               }
                               $scope.isRequesting = false;
                       })
            };
            });

angular.module('starter')
.controller('OrderDetailCtrl', function ($scope, $stateParams, Utils, $window, $http) {
            $scope.orderInfo = {};
            $http.get('http://missxiaohua.com/rest/order/detail', {
                      params: {
                      time: new Date().getTime(),
                      reqStr: JSON.stringify({
                                             orderId: $stateParams.orderId
                                             })
                      }
                      }).then(function (response) {
                              var orders = response.data;
                              if (orders.code === '200') {
                              var ob = orders.obj;
                              var status = ob.status;
                              $scope.orderInfo = {
                                  orderId: ob.orderId,
                                  reserveCode: ob.reserveCode,
                                  submitTime: ob.submitTime,
                                  projectName: ob.projectName,
                                  dealPrice: ob.dealPrice,
                                  marketPrice: ob.marketPrice,
                                  realPayPrice:ob.realPayPrice,
                                  doctorName: ob.doctorName,
                                  hospitalName: ob.hospitalName,
                                  assurancePrice:(ob.assurancePrice!=0?19:0),
                                  statusText: ['', '待支付', '已支付', '已预约', '已完成', '已评价', '已取消'][status]
                              };
                              if (status === 3 || status === 4 || status === 5) {
                              $scope.orderInfo.reserveTime = ob.reserveTime;
                              }
                              if (status === 4 || status === 5) {
                              $scope.orderInfo.completeTime = ob.completeTime;
                              }
                              }
                              else {
                              // 失败
                              }
                              }, function () {
                              // 失败
                              });
            });
angular.module('starter')
.controller('OrderListCtrl', function ($scope, $state, $http,$ionicLoading, Utils) {

            $http.get('http://missxiaohua.com/rest/order/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             orderBy: 'submitTime'
                                             }),
                      time: new Date().getTime()
                      }
                      }).then(function (response) {
                              var orders = response.data;
                              $scope.orderList = [];
                              if (orders.code === '200') {
                              if (orders.obj === null || orders.obj.length === 0) {
                              return;
                              }
                              
                              orders.obj.forEach(function (ob) {
                                                 var result = {
                                                 pic: Utils.getStyledImageUrl(ob.picUrl, {width: 150}),
                                                 status: ob.status,
                                                 submitTime: ob.submitTime,
                                                 dealPrice: ob.dealPrice,
                                                 projectName: ob.projectName,
                                                 reserveCode: ob.reserveCode,
                                                 orderId: ob.orderId,
                                                 reserveTime: ob.reserveTime,
                                                 score: ob.score
                                                 };
                                                 if (ob.status === 1) {
                                                 result.submitTimeStamp = new Date(Date.parse(ob.submitTime.replace(/-/g,"/"))).getTime();
                                                 }
                                                 $scope.orderList.push(result);
                                                 });
                              }
                              });
            
            $scope.payOrder = function (order) {
            $http.get('http://missxiaohua.com/rest/order/pay', {
                      params: {
                      reqStr: JSON.stringify({
                         orderId:order.orderId,
                         tradeType:'APP'
                         })
                      }}).then(function (response) {
                               response = response.data;
                               if (response.code == '200') {
                               var payParam = response.obj;
                               var params = {
                               partnerid: payParam.partnerId, // merchant id
                               prepayid: payParam.prepayId, // prepay id
                               noncestr: payParam.nonceStr, // nonce
                               timestamp: payParam.timeStamp, // timestamp
                               sign: payParam.paySign, // signed string
                               };
                               //alert(Wechat)
                               Wechat.sendPaymentRequest(params, function () {
                                                         $state.go('content.payResult',
                                                                   {reserveCode:order.reserveCode,submitTime:order.submitTime});
                                                         }, function (reason) {
                                                         $ionicLoading.show({
                                                                            template: reason
                                                                            });
                                                         });
                               }else if(response.code == 500){
                               //	$.cookie("msg",json.msg);
                               //location.href="pay_fail.html?" + utils.format2Param({msg: json.msg});
                               }else {
                               // 支付失败
                               }
                               
                               });
            
            };
            });



angular.module('starter')
.controller('PlaceOrderCtrl', function ($scope, $http, $stateParams, $ionicLoading,$state,$ionicPopup) {
            var projectId = $stateParams.projectId;
            
           // $scope.count = $stateParams.count;
            
            function showErrorMsg(msg){
                 $ionicLoading.show({
                      template: msg
                 });
            }
            
            function formatDate(d){//格式化
                 return d<10?'0'+d:d;
            };
            
            $scope.reserve = {};
            $scope.reserve.tel = '';
            $scope.reserve.count = 1;
            $scope.reserve.code = $stateParams.reserveCode;
            $scope.reserve.time = $stateParams.submitTime;
            $scope.validate = false;
            
            $scope.getNewTime = function(d,n){//获取新时间
            d=parseInt(d);
            n=parseInt(n);
            var date=new Date(d),
            y=date.getFullYear(),
            m=date.getMonth(),
            d=date.getDate(),
            D=new Date(y,m+1,d+n),
            h=date.getHours(),
            m=date.getMinutes(),
            s=date.getSeconds();
            return D.getFullYear()+'-'+formatDate(D.getMonth())+'-'+formatDate(D.getDate())+' '+formatDate(h)+':'+formatDate(m)+':'+formatDate(s);
            }
            
            
            if(projectId){
               $http.get('http://missxiaohua.com/rest/project/one', {
                      params: {
                      reqStr: JSON.stringify({
                                             projectId: projectId
                                             })
                      }
                      }).then(function (response) {
                              if (response.status == '200') {
                              var resultObj = response.data.obj;
                                  $scope.reserve.name = resultObj.name;
                                  $scope.reserve.presentPrice = resultObj.presentPrice;
                                  $scope.reserve.nowPayPrice = resultObj.nowPayPrice;
                                  $scope.reserve.totalPrice = resultObj.nowPayPrice;
                                  $scope.reserve.assurance = resultObj.assurancePrice;
                              }else {
                              // fail
                              }
                              }, function () {
                              // fail
                              });
            
            
               //保险
                $scope.reserve.checkbx = false;
            
                $scope.onCheckbx = function(){
                     $scope.reserve.checkbx = !$scope.reserve.checkbx;
                    if($scope.reserve.checkbx){
                      $scope.reserve.totalPrice = parseFloat(parseFloat($scope.reserve.totalPrice)+parseFloat($scope.reserve.assurance)).toFixed(2)
                    }else{
                       $scope.reserve.totalPrice = parseFloat(parseFloat($scope.reserve.totalPrice)-parseFloat($scope.reserve.assurance)).toFixed(2)
                    }
                }
            
                $scope.showBxDetail = function(){
                    var popup = $ionicPopup.show({
                                         title: '',
                                         cssClass: 'xh-bx-detail',
                                         template: '<h3 style="padding-top:0">整形保险</h3><p>整形保险是由小花联合悟空保共同推出的互联网医美私人保险，保障范围包含高频50项医美服务，小花平台补贴投保费至19元，最高保障金额50000元。使花粉们能够安心变美。</p><h3>保障范围</h3><p>微整形：保障肉毒素注射和玻尿酸注射两大类微整形项目，小花补贴投保费至19元（原保费25元），最高保障金额10000元。涵盖过度肿胀、感染、损伤或不对称等风险。</p><p>眼鼻手术：保障眼部手术和鼻部手术两大类整形项目。小花补贴投保费仅19元（原保费80元），最高保障50000元。涵盖面部损伤、假体脱出或严重不对称等风险。</p><h3>客户须知</h3><p>1、被保险人：18-45周岁具有完全行为能力的中国公民（不含港澳台）</p><p>2、投保人：先被保险人本人或医疗机构投保</p><p>3、地区要求：限在中国大陆地区医疗美容机构进行手术</p><p>4、本保险同一被保险人限投保一份，多投无效</p><p>5、本保险同一保险期间内，仅理赔首次注射玻尿酸、肉毒素和首次眼鼻部手术所造成的保险事故，并在承保时约定指定的医院进行手术造成的保险事故。</p><p>6、保险项目及额度</p><div><img style="width:100%" src="img/yuyue/table.jpg"/></div><p>7、以上数据仅供参考，具体详情请联系小花官方客服（微信号：xiaohukefu1）或拨打小花官方客服电话4000305936进行咨询。</p><h3>理赔资料和理赔流程</h3><p>如发生保险事故请您第一时间联系小花官方客服（微信号：xiaohuakefu1，电话：4000305936）按照指引申请理赔。</p>',
                                         buttons: [{
                                                   text: '关闭',
                                                   onTap: function(e) {
                                                     popup.close();
                                                   }
                                                   }]
                                         });
              }
               //代金券
                $scope.coupon = {
                     max:0,
                     id:''
                };
               /* Array.prototype.max = function(){
                   return Math.max.apply({},this)
                }*/
                Array.prototype.max = function() {
                    var max = this[0];var index = 0;
                    for (var i = 1; i <  this.length; i++){
                        if (this[i] > max) {
                            max = this[i];
                            index = i;
                        }
                    } 
                    return [index,max];
                }
               $http.get('http://missxiaohua.com/rest/user/coupon_list', {
                      params: {
                         reqStr: JSON.stringify({})
                      }
                      }).then(function (response) {
                            if (response.data.code === '200') {
                               var couponList = [];
                               response.data.obj.forEach(function(item){
                                   if(parseInt(item.flags)==1){
                                       couponList.push(parseInt(item.money));
                                   }
                                 });
                                /*  if(couponList.length>0){
                                      $scope.coupon.max = couponList.max()[1];
                                      $scope.coupon.id = response.data.obj[couponList.max()[0]].couponId;
                                      $scope.reserve.nowPayPrice = Math.max(($scope.reserve.nowPayPrice-$scope.coupon.max),0.01);
                                  }
                              */
                              if(couponList.length>0){
                                  var bestcp = [];
                                  $http.get('http://missxiaohua.com/rest/user/get_best_coupon',{
                                            params: {
                                               reqStr: JSON.stringify({projectId: projectId})
                                            }
                                        }).then(function(data){
                                            data = data.data;
                                            if(data.code=='200'){
                                            if(data.obj){
                                                bestcp = [data.obj.couponId,data.obj.money];
                                            }else{
                                                bestcp = couponList.max()
                                            }
                                            
                                            $scope.coupon.max = bestcp[1];
                                            $scope.coupon.id = bestcp[0];
                                                
                                            $scope.reserve.totalPrice = Math.max(($scope.reserve.nowPayPrice - $scope.coupon.max),0.01);
                                            
                                            //$('.ui-project-totalPrice').html(parseFloat(nowPayPrice).toFixed(2));
                                            }
                                     })
                                 }
                              }else {
                              
                              }
                              }, function () {
                              
                });
        }

            
      $scope.reserveSubmit = function () {
            
            if ($scope.reserve.tel.length !== 11) {
            showErrorMsg('手机号位数错误');
            return;
            }
            
            $ionicLoading.show({
                               template: '预约下单中,请等待...',
                               noBackdrop:false
                               });
            
            
            $http.post('http://missxiaohua.com/rest/order/place',  {
               reqStr: JSON.stringify({
                                      projectId: projectId,
                                      phone: $scope.reserve.tel,
                                      couponId:$scope.coupon.id,
                                      assurancePrice:($scope.reserve.checkbx?$scope.reserve.assurance:0)
                                })
               }).then(function (data) {
                       data = data.data;
                       if (data.code == '200') {
                        $http.get('http://missxiaohua.com/rest/order/pay', {
                           params: {
                           reqStr: JSON.stringify({
                                  orderId: data.obj.orderId,
                                  tradeType:'APP'
                                })
                           }}).then(function (response) {
                            response = response.data;
                            if (response.code == '200') {
                            var payParam = response.obj;
                            var params = {
                                partnerid: payParam.partnerId, // merchant id
                                prepayid: payParam.prepayId, // prepay id
                                noncestr: payParam.nonceStr, // nonce
                                timestamp: payParam.timeStamp, // timestamp
                                sign: payParam.paySign, // signed string
                            };
                            //alert(Wechat)
                            Wechat.sendPaymentRequest(params, function () {
                                  $state.go('content.payResult',
                                            {reserveCode:data.obj.reserveCode,submitTime:data.obj.submitTime});
                                  }, function (reason) {
                                  $ionicLoading.show({
                                                     template: reason
                                                     });
                                  });
                            }else if(response.code == 500){
                            $ionicLoading.show({
                                               template: "下单失败，请重试"
                                               });
                            
                            }else {
                            // 支付失败
                            }
                            
                            });
         
         }else if(data.code == '500') {
         $state.go('login');
         }else{
             showErrorMsg('预约失败');
         }
         
         });
        }
});

angular.module('starter')
.controller('ProjectDetailCtrl', function ($scope, $ionicPopup, $ionicSlideBoxDelegate, $stateParams, Utils, $http, $state) {
            var projectId = $stateParams.projectId;
            
            //美恰
            _MEIQIA('metadata', {
                    phone: localStorage.userName, // 自定义字段
                    });
           
            _MEIQIA('getPanelVisibility', function(v){
                    if (v === 'visible') {
                    } else {
                    cordova.plugins.Keyboard.close();
                    }
                });

            $http.get('http://missxiaohua.com/rest/project/one', {
                      params: {
                      reqStr: {
                      projectId: projectId
                      }
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              $scope.projectDetail = response.data.obj;
                              if(null == $scope.projectDetail.hospitalQualification || undefined == typeof($scope.projectDetail.hospitalQualification)) {
                              $scope.projectDetail.hospitalQualification = "公立三级甲等";
                              }
                              
                              if ($scope.projectDetail.isAuthenticated) {
                              $scope.projectDetail.authenticate_url = "img/project/project_list/authenticate_yes.png";
                              }
                              else {
                              $scope.projectDetail.authenticate_url = "img/project/project_list/authenticate_no.png";
                              }
                              
                              $scope.projectDetail.urls = $scope.projectDetail.pics.split(",");
                              
                              var projectContentElem = angular.element(document.getElementById("project_detail_discribe"));
                              var content = $scope.projectDetail.content;
                              if (null != content && typeof content == "string") {
                              content = content.replace(/\r\n/g, "<br />");
                              content = content.replace(/\n/g, "<br />");
                              }
                              projectContentElem.html(content || "");
                              
                              var hospitalName = angular.element("#project-detail .hospital .name").eq(0);
                              var hospitalAuthBadge = angular.element("#project-detail").children(".hospital .badge").eq(0);
                              hospitalAuthBadge.css("left", getRelativeLeft(hospitalName, 9));
                              hospitalAuthBadge.css("top", getRelativeTop(hospitalName, 0));
                              
                              //项目效果
                              if($scope.projectDetail.effect){
                              var effect = $scope.projectDetail.effect;
                              if (null != effect && typeof effect == "string") {
                              effect = effect.replace(/\r\n/g, "<br />");
                              effect = effect.replace(/\n/g, "<br />");
                              }
                              $scope.projectDetail.effect = effect;
                              }
                              var hospitalName = angular.element("#project-detail .hospital .name").eq(0);
                              var hospitalAuthBadge = angular.element("#project-detail").children(".hospital .badge").eq(0);
                              hospitalAuthBadge.css("left", getRelativeLeft(hospitalName, 9));
                              hospitalAuthBadge.css("top", getRelativeTop(hospitalName, 0));
                              
                              //注意事项
                              if($scope.projectDetail.attention)
                              $scope.projectDetail.attention = '<p>'+ $scope.projectDetail.attention.replace('<br>','</p><p>')+'</p>';
                              
                              //常见问题 
                              if($scope.projectDetail.details)
                              $scope.projectDetail.details = '<p>'+ $scope.projectDetail.details.replace('<br>','</p><p>')+'</p>';

                              
                              }
                              else {
                              // fail
                              }
                              });
            
            $scope.jumpToHospital = function(hospitalId) {
            $state.go('content.hospitalDetail', {
                      hospitalId: hospitalId
                      });
            };
            
            $scope.jumpToDoctor = function(doctorId) {
            $state.go('content.doctorDetail', {
                      doctorId: doctorId
                      });
            };
            
            $scope.placeOrder = function(projectId) {
            $state.go('content.placeOrder',{
                      projectId:projectId
                      })
            };
            
            var getRelativeLeft = function(relativeElem, offset) {
            if (null == relativeElem || !(typeof offset === 'number')) {
            return 0;
            }
            
            var position = relativeElem.position();
            var elemLeft = position.left;
            var elemWidth = relativeElem.width();
            
            return elemLeft + elemWidth + offset;
            }
            
            var getRelativeTop = function(relativeElem, offset) {
            if (null == relativeElem || !(typeof offset === 'number')) {
            return 0;
            }
            
            var elemTop = relativeElem.position().top;
            
            return elemTop + offset;
            }
            $("#project-detail-body").css("display","block");
            $scope.getReviewList = function (doctorId) {
            //获取评论列表
            $http.get('http://missxiaohua.com/rest/project_comment/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             projectId: projectId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var result = response.data;
                              $scope.objArr = result.obj;
                              $scope.size = result.obj.length;
                              if($scope.size == 0){
                              $(".loadingMore").hide();
                              return;
                              }
                              for (var i = 0; i < $scope.size; ++i) {
                              $scope.objArr[i].headImgUrl = $scope.objArr[i].headImgUrl || "img/default_user_head.png";
                              }
                              }
                              });
            }
            $scope.getReviewList(projectId);
            //默认加载评论列表
            //显示全部
            $scope.showAll = function () {
            $(".reviews>dl").css("display","block");
            $(".loadingMore").hide();
            }
            
            var slideHandle = $ionicSlideBoxDelegate.$getByHandle("project-detail-slide");
            $scope.next = function() {
            $scope.$broadcast('slideBox.nextSlide');
            };
            
            $scope.pagerClick = function(index) {
            slideHandle.slide(index, 0);
            };
            
            $scope.slideChanged = function(index) {
            };
            });

angular.module('starter')
.controller('ProjectListCtrl', function ($scope, $stateParams, SlideDownMenu, Utils, $http, CityList, $window, $timeout, $ionicScrollDelegate, $state) {
            var subCategoryName = $stateParams.subCategoryName;
            var subCategoryId = $stateParams.subCategoryId;
            // For the third category, its parent category is the current sub category.
            var parentCategoryId = subCategoryId;
            var city = null;
            var province = null;
            var categoryId = null;
            var orderType = null;
            var order = "desc";
            var pageNo = 0;
            var pageSize = 0;
            var previousPageNo = 0;
            var hasMoreData = true;
            
            var initListStatus = function() {
            pageNo = 1;
            pageSize = 6;
            previousPageNo = pageNo - 1;
            hasMoreData = true;
            $scope.projectsList = [];
            };
            initListStatus();
            
            function loadThirdCategories(subCategoryId) {
            var result = [{value: subCategoryId, name: "全部"}];
            $http.get('http://missxiaohua.com/rest/category/list', {
                      params: {
                      reqStr: JSON.stringify({
                                             parentCategoryId: parentCategoryId
                                             })
                      }
                      }).then(function (response) {
                              if (response.data.code === '200') {
                              var subCategories = response.data.obj;
                              for (var i = 0; i < subCategories.length; ++i) {
                              result.push({value: subCategories[i].categoryId, name: subCategories[i].name});
                              }
                              }
                              }).finally(function () {
                                         $scope.thirdCategories = result;
                                         });
            }
            $scope.thirdCategories = [];
            loadThirdCategories(subCategoryId);
            
            $scope.thirdCategoryDefault = "全部";
            $scope.orderTypes = [
                                 {name: '默认', value: ''},
                                 {name: '销量', value: 'salesVolume'},
                                 {name: '价格低到高', value: 'presentPrice:asc'},
                                 {name: '价格高到低', value: 'presentPrice:desc'}
                                 ];
            $scope.orderTypeDefault = "默认";
            $scope.provinces = CityList;
            $scope.cityDefault = "全国";
            SlideDownMenu.setValue('city-filter','全国')
            
            var loadProjectsList = function() {
            console.log('loadproject')
            // Needn't parent ID when load subcategory projects.
            var pId = parentCategoryId;
            if (null != categoryId && "" != categoryId) {
                pId = null;
            }
            
            var listParams = {
                parentCategoryId: pId,
                categoryId: categoryId,
                city: city,
                province: province,
                orderBy: orderType,
                order: order,
                page: pageNo,
                size: pageSize
            };
            // Strip the null params.
            for (var key in listParams) {
                if (listParams.hasOwnProperty(key) && null == listParams[key]) {
                    delete listParams[key];
                }
            }
            
            var updatePageInfo = function(objArray) {
            if (null == objArray || objArray.length < pageSize) {
            hasMoreData = false;
            return;
            }
            
            $timeout(function() {++pageNo;}, 1000);
            };
            
            // To avoid the ion-infinite-scroll call twice bug.
            // See http://forum.ionicframework.com/t/on-infinite-called-twice-when-using-ion-infinite-scroll/5216
            //     http://stackoverflow.com/questions/27359867/infinite-scrolling-with-http-get-firing-twice
            if (pageNo == previousPageNo) {
            return;
            }
            previousPageNo = pageNo;

            $http.get('http://missxiaohua.com/rest/project/list', {
                      params: {
                         reqStr: Utils.trimObject(listParams)
                      }
                      }).then(function (response) {
                              if (response.data.code !== '200') {
                                  return;
                              }
                              var projectsList = response.data.obj;
                              
                              updatePageInfo(projectsList);
                              for (var i = 0; i < projectsList.length; ++i) {
                              // Introduction and details may have only one.
                              // Fixed by zhaoyuankui, 2015/8/9.
                              var introduction = projectsList[i].introduction;
                              var details = projectsList[i].details;
                              if (null == introduction || "" == introduction) {
                              if (null != details && "" != details) {
                              projectsList[i].introduction = details;
                              }
                              }
                              if (null == details || "" == details) {
                              if (null != introduction && "" != introduction) {
                              projectsList[i].details = introduction;
                              }
                              }
                              
                              // The coverPicUrl was deprecated.
                              if (null == projectsList[i].coverPicUrl) {
                              var pics = projectsList[i].pics.split(",");
                              if (pics.length >= 1) {
                              projectsList[i].coverPicUrl = pics[0];
                              }
                              }
                              
                              if (projectsList[i].isAuthenticated) {
                              projectsList[i].authenticate_url = "img/project/project_list/authenticate_yes.png";
                              }
                              else {
                              projectsList[i].authenticate_url = "img/project/project_list/authenticate_no.png";
                              }
                              
                            //  projectsList[i].coverPicUrl = Utils.getStyledImageUrl(projectsList[i].coverPicUrl, {width: 132, height: 106});
                              
                              $scope.projectsList.push(projectsList[i]);
                              }
                              });
            };
            
            //loadProjectsList();
            
            $scope.loadMore = function() {
                loadProjectsList();
            // Fix the bug. See http://forum.ionicframework.com/t/resolved-issue-beta-14-ion-infinite-scroll-keep-on-calling-the-method-of-on-infinite/14301
            //          $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            };
            $scope.moreDataCanBeLoaded = function() {
            return hasMoreData;
            };
            
            $scope.onClickProject = function ($index) {
            $state.go('content.projectDetail', {
                      projectId: $scope.projectsList[$index].projectId
                      });
            };
            
            var onThirdCategoryChanged = function(newVal, oldVal, scope) {
            if (null == newVal) {
            return;
            }
            
            categoryId = newVal;
            // Selected the parent category as total.
            if (parentCategoryId == categoryId) {
            categoryId = null;
            }
            
            initListStatus();
            loadProjectsList();
            $ionicScrollDelegate.$getByHandle("project-scroll-list").scrollTop();
            }
            
            var onOrderTypeChanged = function(newVal, oldVal, scope) {
            if (null == newVal) {
            return;
            }
            
            var orderInfo = newVal;
            // Select the default.
            if ("" == orderInfo) {
            orderType = null;
            order = null;
            }
            else {
            var orderInfos = orderInfo.split(':');
            orderType = orderInfos[0];
            order = orderInfos[1] || "desc";
            }
            initListStatus();
            loadProjectsList();
            $ionicScrollDelegate.$getByHandle("project-scroll-list").scrollTop();
            }
            
            var onCityFilterChanged = function(newVal, oldVal, scope) {
            console.log(newVal+'  '+oldVal)
                if (null == newVal) {
                    return;
                }
                
                var idxColon = newVal.indexOf(":");
                if (-1 == idxColon) {
                // Only the “全国” situation is valid.
                if ("全国" == newVal) {
                  province = null;
                  city = null;
                }
                else {
                  return;
                }
                }
                else {
                    // province:city
                    province = newVal.substring(0, idxColon);
                    city = newVal.substring(idxColon + 1);
                }
                initListStatus();
                loadProjectsList();
                $ionicScrollDelegate.$getByHandle("project-scroll-list").scrollTop();
            }
            
            SlideDownMenu.watch($scope, "third-category", onThirdCategoryChanged);
            SlideDownMenu.watch($scope, "order-type", onOrderTypeChanged);
            SlideDownMenu.watch($scope, "city-filter", onCityFilterChanged);
            $scope.$on('$ionicView.afterEnter',function(){
                      
            })
    });

angular.module('starter')
.controller('ReportCtrl', function ($scope, $http,$state,$ionicLoading,Utils) {
            $scope.credits= {
            finished:false,
            uname:'',
            phone:'',
            id:''
            };
            $scope.showCreditResult = function () {
                if( $scope.credits.uname!=''&& $scope.credits.phone!=''&& $scope.credits.id!=''){
                    $scope.credits.finished = true;
                    cordova.plugins.Keyboard.close();
                    Utils.doStatic('?info=xindai&userid='+localStorage.userid+'&name='+$scope.credits.uname+'&tel='+$scope.credits.phone+'&id='+$scope.credits.id+'&time='+(new Date()).getTime());
                }else{
                    $ionicLoading.show({template:'请填写完整信息'});
                }
            };
            
            
            function addReport()
            {
            var param = {
            userId : "interface_not_ready",
            doctorId : $scope.infos.doctorName,
            projectId : $scope.infos.projectName,
            reason : $scope.infos.reportDesc,
            status : -1,
            phone : $scope.infos.telephone,
            hospitalId : $scope.infos.hospitalName
            }
            //console.log("http://missxiaohua.com/rest/complaint/create?reqStr="+JSON.stringify(param));
            $http.get("http://missxiaohua.com/rest/complaint/create?reqStr="+JSON.stringify(param))
            .success(function(data, status, headers, config) {
                     if(data.code==200){
                     $ionicLoading.show({
                                        template: '投诉提交成功'
                                        });
                     $state.go('content.home');
                     } else if(data.code == '500') {
                     $state.go('login');
                     }else {
                     alert('提交失败');
                     }
                     })
            .error(function(data, status, headers, config) {
                   alert('提交失败');
                   });
            }
            
            $scope.formSubmit = function(reportForm){
            if (reportForm.$valid) {
            addReport();
            }else{
            $ionicLoading.show({
                               template: '提交信息填写有误'
                               });
            
            }
            };
            
            $scope.infos = {
            reportDesc: "包括手术期间，手术目前的问题，并请留下您的手机号。客服接到投诉后会在24小时内回电。谢谢。",
            doctorName:"",
            projectName:"",
            reportDesc:"",
            telephone:"",
            hospitalName:""
            };
            //a=document.getElementById('user-report').getElementsByClassName('list')[0].style.minHeight=document.body.scrollHeight+'px';
            });

angular.module('starter')
.controller('UserCenterCtrl', function ($scope, Utils, User, $http, $state,$cordovaFileTransfer, $ionicPopup, $ionicActionSheet, $ionicLoading, $q) {
            $scope.hasLogin = User.getUserInfo().hasLogin;
            
            $scope.userInfo = {};
            
            $scope.isWeixin = Utils.isWeixin();
            $scope.requestStatus = 'loading';
            $scope.showModfyNickName = false;
            
            $http.get('http://missxiaohua.com/rest/user/info', {
                      params: {
                          time: new Date().getTime()
                      }
                      }).then(function (response) {
                              var resp = response.data;
                        
                              if (resp.code === '200') {
                                  var ob = resp.obj;
                                  var nickName = ob.nickName;
                                  var phoneName = ob.phone;
                                  var headSize = Utils.getElementSize("#headUrl");
                                  //var headImgUrl = Utils.getStyledImageUrl(ob.headImgUrl, {width: headSize.width, height: headSize.width});
                                  var headUrl = ob.headImgUrl || "img/default_user_head.png";
                                  var userId = ob.userId;
                                  var openId = ob.openId;
                                  
                                  $scope.userInfo.showName = nickName || phoneName;
                                  $scope.userInfo.showNameToModify = $scope.userInfo.showName;
                                  $scope.userInfo.userId = userId;
                                  
                                  $scope.headUrl = headUrl;
                              
                                  $scope.requestStatus = 'success';
                              }
                              else {
                                  $scope.requestStatus = 'error';
                              }
                              }, function () {
                                  $scope.requestStatus = 'error';
                              });

            $scope.changeHead = function () {
            // angular.element('#head-image-input').click();
            var options = {
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            saveToPhotoAlbum: true
            };
            
            //Camera.getPicture(type)->根据选择的“选取图片”的方式进行选取
            navigator.camera.getPicture(function (imageURI) {
                                        // $scope.me.image = imageURI;
                                        //更新页面上的照片
                                        $scope.headUrl = imageURI;
                                        
                                        $cordovaFileTransfer.upload(
                                                        'http://missxiaohua.com/rest/file/upload',
                                                        imageURI, {
                                                        encodeURI:true,
                                                        timeout:5000
                                                    })
                                        .then(function(result) {
                                              // Success!
                                              $http.get('http://missxiaohua.com/rest/user/change_head', {
                                                        params: {
                                                        reqStr: JSON.stringify({sysHeadImgUrl: JSON.parse(result.response).obj})
                                                        }
                                                        }).then(function (response) {
                                                                $ionicLoading.hide();
                                                                if (response.data.code !== '200'){
                                                                $ionicLoading.show({
                                                                                   template: '上传头像失败请稍后再试'
                                                                                   });
                                                                }else{
                                                                
                                                                $scope.$apply();
                                                                }
                                                                });
                                              
                                              }, function(err) {
                                              }, function (progress) {
                                                 // constant progress updates
                                              $ionicLoading.show({template:'头像上传中'});
                                              });
                                        
                                        }, function (error) {
                                        //error handle
                                        console.log("Error: " + error);
                                        }, options);
            
            };
            
            
            $scope.changeAccount = function () {
                localStorage.hasLogin = false;
                $state.go('content.changeUser');
            };
            
            $scope.modifyNickName = function () {
               //$scope.showModfyNickName = true;
               angular.element('#modify-nickname-input').focus();
            
               var popup = $ionicPopup.show({
                                         title: '修改昵称',
                                         template: '<input style="border:1px solid #ddd;padding-left:5px;" type="text" ng-model="userInfo.newNickName">',
                                         scope: $scope,
                                         buttons: [{
                                                   text: '关闭',
                                                   onTap: function(e) {
                                                      popup.close();
                                                   }
                                                   },{
                                                   text: '确认',
                                                   onTap: function(e) {
                                                       var nickName = $scope.userInfo.newNickName;
                                                       if (!nickName||nickName == $scope.userInfo.showName) {
                                                            e.preventDefault();
                                                       }else if (nickName == '小花' || nickName == '小花园长' || nickName == '小花官方'  ) {
                                                             $ionicLoading.show({
                                                                          template: '昵称已被使用，请更换'
                                                                          });
                                                              e.preventDefault();
                                                   }else{
                                                       $http.get('http://missxiaohua.com/rest/user/rename', {
                                                             params: {
                                                                reqStr: JSON.stringify({sysNickName: nickName})
                                                             }
                                                             }).then(function (response) {
                                                                 if (response.data.code === '200') {
                                                                     $scope.userInfo.showName = nickName;
                                                                     $ionicLoading.show({
                                                                                        template: '昵称修改成功'
                                                                                        });

                                                                     return nickName;
                                                                    }
                                                             })
                                                   
                                                   }
                                                   }
                                            }]
                                         });
            };
            

            //我的消息
            $scope.messagNum = localStorage.messagNum;
        });
